<?php
include_once ( WPT_PLUGIN_DIR."/includes/libs/phpquery.php" );

function wpt_clickbank_options_admin($self) {
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_clickbank_response($params) {
  $options = get_option("wpt_options");
  $options = is_array($options) ? $options : unserialize($options);

  ksort($params);

  $request_query = array();
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);
  
  $request = "http://www.clickbank.com/mkplSearchResult.htm?".$request_query;

  $response = wpt_get_response( $request, "ClickBank" );
  $_response = phpQuery::newDocument($response);
  $output = array();
  $_cb_rows = $_response->find("div.results")->find("tr.result");
  $cbaf = ( !empty($options['wpt_clickbank_aff_nick']) ) ? $options['wpt_clickbank_aff_nick'] : "zzzzz";
  foreach( $_cb_rows as $k => $cb_row ) {
    $_cb_row = pq($cb_row);
    $_cb_stats = $_response->find("div.results")->find("td.stats:eq($k)")->find("span.statWrap");
    $stats = array();
    foreach( $_cb_stats as $cb_stat ) {
      $_cb_stat = pq($cb_stat);
      $stat_label = str_replace( array("\n", "\r"), array(" ", " "), trim($_cb_stat->find(">label")->html()) );
      $stat_data = str_replace( array("\n", "\r", "$"), array(" ", " ", "$ "), trim($_cb_stat->find("span.stat")->html()) );
      $stats[] = '<span class="cb-stat"><span class="stat-label">'.$stat_label.'</span> <span class="stat-data">'.$stat_data.'</span></span>';
    }
    $output[] = (object)array(
      "title" => $_cb_row->find("td.details")->find("h4>a")->html(),
      "url" => str_replace( "zzzzz", $cbaf, $_cb_row->find("td.details")->find("h4>a")->attr("href")),
      "description" => $_cb_row->find("td.details")->find("div.description")->html(),
      "avg_commission" => trim(str_replace( "$", "$ ", $_cb_row->find("td.promote")->find("span.commission")->html() )),
      "clickbank_stats" => join("\n", $stats),
    );
  }
  return $output;
}

function wpt_clickbank_post($params) {
  global $wpdb, $wpt;
  
  extract($params);
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));
  
  if( isset($featured_image_module) && $featured_image_module == "{".$this_module_name."-fi}" ) {
    $featured_image_tt_index = array_search( "{".$featured_image_module_tag."}", $wpt_clickbank_template_tags );
  }

  if($keywords == "") {
    return send_module_errors("ClickBank", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/10 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 10 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'clickbank'");
  if($template == false || empty($template)) {
    return send_module_errors("ClickBank", "[Keywords Empty] Module Template was not found.");
  }

  $options = $wpt->options;

  $output = array();

  for($i = 0; $i < $count; $i++) {
    $cb_response = wpt_clickbank_response(array(
                                        "includeKeywords" => urlencode($keywords),
                                        "firstResult" => $start + 1,
                                      ));
    
    $count_this = ($count <= 10) ? $count : 10;
    
    $counter2 = 0;
    $counter1 = 1;

    if (!$cb_response) {
      return send_module_errors("ClickBank", "[Request Failed] API request failed." );
    }

    if ( (count($cb_response) < 1)) {
      return send_module_errors("ClickBank", "[Content Empty] No clickbank items found for this keyword.");
    }
    
    foreach($cb_response as $cb_item) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;
      if ($counter2<$count_this) {
        $content = $template;

        $content_search_tags = $wpt_clickbank_template_tags;
        
        $content_replace_tags = array(
          $keywords,
          (string)$cb_item->title,
          (string)$cb_item->url,
          (string)$cb_item->description,
          (string)$cb_item->avg_commission,
          (string)$cb_item->clickbank_stats,
        );
        
        $content = str_replace($content_search_tags, $content_replace_tags, $content);

        $post_data = array(
          "uid" => md5($cb_item->url.$cb_item->title),
          "title" => $cb_item->title,
          "content" => $content,
          "featured_image" => ( isset($featured_image_tt_index) && $featured_image_tt_index !== FALSE ) ? (string)$content_replace_tags[$featured_image_tt_index] : "",
        );
        array_push($output, $post_data);
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_clickbank_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_clickbank_module_template_installed") != "Yes") {
    $wpt->set_template("clickbank", $wpt_clickbank_default_module_template);
    update_option("wpt_clickbank_module_template_installed", "Yes");
  }
  if(get_option("wpt_clickbank_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_clickbank_default_post_template);
    update_option("wpt_clickbank_post_template_installed", "Yes");
  }
}
?>
