<?php
include_once ( ABSPATH.WPINC."/feed.php" );
include_once ( WPT_PLUGIN_DIR."/includes/libs/phpquery.php" );

function wpt_ebay_options_admin($self) {
  include(dirname(__file__)."/wptm-options.php");
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_ebay_post_optional_settings($self, $form_data=array()) {
  include(dirname(__file__)."/wptm-options.php");
  include(dirname(__file__)."/templates/post-optional-settings.php");
}

function wpt_ebay_response($params) {
  $options = get_option("wpt_options");
  $options = is_array($options) ? $options : unserialize($options);
  $per_page = 10;
  $page = 1;
  
  $default_params = array(
    "output"=>"RSS20",
    "FeedName"=>"SearchResults",
    "afepn"=>urlencode($options['wpt_ebay_affid']),
    "siteId"=>$options['wpt_ebay_country'],
    "salic"=>$options['wpt_ebay_country']
  );
  
  if( isset($params['frpp']) ) {
    $page = $params['frpp'];
    unset( $params['frpp'] );
  }
  
  $start = ($page - 1) * $per_page;
  
  $params = array_merge($params, $default_params);
  ksort($params);

  $request_query = array();
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);
  $request = "http://rss.api.ebay.com/ws/rssapi?".$request_query;

  $feed_data = fetch_feed($request);
  if (!$feed_data || empty( $feed_data ) || $feed_data === false ) {
    return send_module_errors("eBay", "[Loading Error] Failed to load eBay Data." );
  }
  $output = array();
  $feed_items = $feed_data->get_items($start, $per_page); 
  foreach( $feed_items as $item ) {
    $description = $item->get_description();
    $description = str_replace( array("$", "|"), array("$ ", ""), $description );
    $_description = phpQuery::newDocument($description);
    $_desc_links = $_description->find("td:eq(1)>a");
    $bid_now_url = "";
    $buy_now_url = "";
    $add_to_wish_list_url = "";
    $add_to_watch_list_url = "";
    $_description_without_links = $_description;
    $uniqid = uniqid();
    foreach( $_desc_links as $k => $_desc_link ) {
      if( strtolower(trim(pq($_desc_link)->text())) == "bid now" ) {
        $bid_now_url = pq($_desc_link)->attr("href");
        $_description_without_links->find("td:eq(1)>a:eq($k)")->addClass("remove-".$uniqid);
      }
      if( strtolower(trim(pq($_desc_link)->text())) == "buy it now" ) {
        $buy_now_url = pq($_desc_link)->attr("href");
        $_description_without_links->find("td:eq(1)>a:eq($k)")->addClass("remove-".$uniqid);
      }
      if( strtolower(trim(pq($_desc_link)->text())) == "add to wish list" ) {
        $add_to_wish_list_url = pq($_desc_link)->attr("href");
        $_description_without_links->find("td:eq(1)>a:eq($k)")->addClass("remove-".$uniqid);
      }
      if( strtolower(trim(pq($_desc_link)->text())) == "add to watch list" ) {
        $add_to_watch_list_url = pq($_desc_link)->attr("href");
        $_description_without_links->find("td:eq(1)>a:eq($k)")->addClass("remove-".$uniqid);
      }
    }
    $_description_without_links->find("td:eq(1)>a.remove-$uniqid")->remove();
    $currentprice = $item->get_item_tags('urn:ebay:apis:eBLBaseComponents','CurrentPrice');
    $endtime = $item->get_item_tags('urn:ebay:apis:eBLBaseComponents','EndTime');
    $bidcount = $item->get_item_tags('urn:ebay:apis:eBLBaseComponents','BidCount');
    $auctiontype = $item->get_item_tags('urn:ebay:apis:eBLBaseComponents','AuctionType');
    $itemcharacteristic = $item->get_item_tags('urn:ebay:apis:eBLBaseComponents','ItemCharacteristic');
    $output[] = array(
      'title' => $item->get_title(),
      'link' => $item->get_link(),
      'guid' => $item->get_id(true),
      'pubdate' => $item->get_date(),
      'currentprice' => $currentprice[0]['data'],
      'endtime' => date("F d, Y h:i A",$endtime[0]['data']),
      'bidcount' => $bidcount[0]['data'],
      'auctiontype' => $auctiontype[0]['data'],
      'itemcharacteristic' => $itemcharacteristic[0]['data'],
      'summary' => $item->get_description(),
      'thumbnail_url' => $_description->find("td:first>a>img")->attr("src"),
      'description' => $_description_without_links->find("td:eq(1)")->html(),
      'bid_now_url' => $bid_now_url,
      'buy_now_url' => $buy_now_url,
      'add_to_wish_list_url' => $add_to_wish_list_url,
      'add_to_watch_list_url' => $add_to_watch_list_url,
    );
  }
  if( !empty( $output ) )
    return $output;
  else 
    return send_module_errors("eBay", "[Empty Output] The output was empty." );
}

function wpt_ebay_post($params) {
  global $wpdb, $wpt;
  extract($params);
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));
  
  if( isset($featured_image_module) && $featured_image_module == "{".$this_module_name."-fi}" ) {
    $featured_image_tt_index = array_search( "{".$featured_image_module_tag."}", $wpt_ebay_template_tags );
  }

  $ebay_category = $campaign_meta["ebay_category"];
  if($ebay_category == "all" || empty( $ebay_category ) || !isset($ebay_category))
    $ebay_category = "all";

  if($keywords == "") {
    return send_module_errors("eBay", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/10 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 10 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'ebay'");
  if($template == false || empty($template)) {
    return send_module_errors("eBay", "[Keywords Empty] Module Template was not found.");
  }

  $output = array();
  
  $content = $template;
  
  for($i = 0; $i < $count; $i++) {
    $response_params = array(
                            "customid" => urlencode($keywords),
                            "satitle" => urlencode($keywords),
                            "sacat" => $ebay_category,
                            "frpp" => $page,
                            );
    if( $ebay_category == "all" || empty($ebay_category) ) 
      unset( $response_params['sacat'] );

    $ebay_xml_response = wpt_ebay_response($response_params);

    if(!empty($ebay_xml_response["error"]))
      return $ebay_xml_response;
    $count_this = ($count <= 10) ? $count : 10;
    
    $counter2 = 0;
    $counter1 = 1;

    foreach($ebay_xml_response as $item) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;

      if ($counter2<$count_this) {
        $bid_now_link = (!empty($item['bid_now_url'])) ? '<a href="'.$item['bid_now_url'].'" target="_blank">Bid Now</a>' : "";
        $buy_now_link = (!empty($item['buy_now_url'])) ? '<a href="'.$item['buy_now_url'].'" target="_blank">Buy Now</a>' : "";
        $add_to_wish_list_link = (!empty($item['add_to_wish_list_url'])) ? '<a href="'.$item['add_to_wish_list_url'].'" target="_blank">Add to Wish List</a>' : "";
        $add_to_watch_list_link = (!empty($item['add_to_watch_list_url'])) ? '<a href="'.$item['add_to_watch_list_url'].'" target="_blank">Add to Watch List</a>' : "";
        
        $content_search_tags = $wpt_ebay_template_tags;
        
        $content_replace_tags = array(
          $keywords,
          $item['title'],
          $item['link'],
          $item['guid'],
          $item['pubdate'],
          $item['currentprice'],
          $item['endtime'],
          $item['bidcount'],
          $item['auctiontype'],
          $item['itemcharacteristic'],
          $item['summary'],
          '<img src="'.$item['thumbnail_url'].'" alt="'.$item['title'].'" />',
          $item['thumbnail_url'],
          $item['description'],
          $bid_now_link,
          $buy_now_link,
          $add_to_wish_list_link,
          $add_to_watch_list_link,
          $item['bid_now_url'],
          $item['buy_now_url'],
          $item['add_to_wish_list_url'],
          $item['add_to_watch_list_url'],
        );
        
        $content = str_replace($content_search_tags, $content_replace_tags, $content);

        $post_data = array(
          "uid" => md5($item['guid']),
          "title" => $item['title'],
          "content" => $content,
          "featured_image" => ( isset($featured_image_tt_index) && $featured_image_tt_index !== FALSE ) ? (string)$content_replace_tags[$featured_image_tt_index] : "",
        );
        array_push($output, $post_data);
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_ebay_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_ebay_module_template_installed") != "Yes") {
    $wpt->set_template("ebay", $wpt_ebay_default_module_template);
    update_option("wpt_ebay_module_template_installed", "Yes");
  }
  if(get_option("wpt_ebay_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_ebay_default_post_template);
    update_option("wpt_ebay_post_template_installed", "Yes");
  }
}

?>
