<?php

function wpt_oodle_options_admin($self) {
  include(dirname(__file__)."/wptm-options.php");
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_oodle_post_optional_settings($self, $form_data=array(), $ct = '') {
  include(dirname(__file__)."/wptm-options.php");
  include(dirname(__file__)."/templates/post-optional-settings.php");
}

function wpt_oodle_response($params) {
  $options = get_option("wpt_options");
  $options = is_array($options) ? $options : unserialize($options);
  $default_params = array(
    "key" => $options['wpt_oodle_apikey'],
    "num" => "10",
    "sort" => $options['wpt_oodle_sort'],
    "region" => $options['wpt_oodle_country']
  );
  
  if( isset( $params['oodle_region'] ) ) {
    $default_params['region'] = $params['oodle_region'];
    unset( $params['oodle_region'] );
  }
  
  if( isset( $params['oodle_category'] ) ) {
    $default_params['category'] = $params['oodle_category'];
    unset( $params['oodle_category'] );
  }
  
  $params = array_merge($params, $default_params);
  ksort($params);

  $request_query = array();
  
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);

  $request = "http://api.oodle.com/api/v2/listings?".$request_query;

  return wpt_get_xml_response( $request, "Oodle" );
}

function wpt_oodle_post($params) {
  global $wpdb, $wpt;

  extract($params);
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));
  
  if( isset($featured_image_module) && $featured_image_module == "{".$this_module_name."-fi}" ) {
    $featured_image_tt_index = array_search( "{".$featured_image_module_tag."}", $wpt_oodle_template_tags );
  }
  
  if($keywords == "") {
    return send_module_errors("Oodle", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/10 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 10 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'oodle'");
  if($template == false || empty($template)) {
    return send_module_errors("Oodle", "[Keywords Empty] Module Template was not found.");
  }

  $options = $wpt->options;

  $output = array();

  for($i = 0; $i < $count; $i++) {
    $response_array = array(
                            "q" => urlencode($keywords),
                            "start" => $start+1,
                          );
    if( isset( $campaign_meta['oodle_region'] ) && !empty( $campaign_meta['oodle_region'] ) )
      $response_array['oodle_region'] = $campaign_meta['oodle_region'];

    if( isset( $campaign_meta['oodle_category'] ) && !empty( $campaign_meta['oodle_category'] ) )
      $response_array['oodle_category'] = $campaign_meta['oodle_category'];

    $oodle_xml_response = wpt_oodle_response($response_array);

    if(!empty($oodle_xml_response["error"]))
      return $oodle_xml_response;
    $count_this = ($count <= 10) ? $count : 10;
    
    $counter2 = 0;
    $counter1 = 1;

    if (!$oodle_xml_response) {
      return send_module_errors("Oodle", "[Request Failed] API request failed." );
    }

    if (isset($oodle_xml_response->error) && !empty($oodle_xml_response->error)) {
      return send_module_errors("Oodle", "[Request Failed] API request failed with the following error: ".$oodle_xml_response->error );
    }
    
    if (!isset($oodle_xml_response->listings) || empty( $oodle_xml_response->listings ) || count($oodle_xml_response->listings->element) < 1) {
      return send_module_errors("Oodle", "[Empty Content] No content was found for the keyword." );
    }


    foreach($oodle_xml_response->listings->element as $oodle) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;

      if ($counter2<$count_this) {
        $content = $template;
        $image_gallery = array();
        if( !empty($oodle->images->element) && count($oodle->images->element) > 0 ) {
          $oodle_images = array();
          foreach( $oodle->images->element as $image ) {
            $oodle_images[(string)$image->num][(string)$image->size] = array(
              "src" => (string)$image->src,
              "width" => (string)$image->width,
              "height" => (string)$image->height,
              "alt" => (string)$image->alt,
            );
          }
          foreach($oodle_images as $oodle_image) {
            $image_gallery[] = '<a href="'.$oodle_image['j']['src'].'"><img src="'.$oodle_image['s']['src'].'" alt="'.$oodle_image['s']['alt'].'" /></a>';
          }
        }
        
        $content_search_tags = $wpt_oodle_template_tags;
        
        $content_replace_tags = array(
          $keywords,
          (string)$oodle->title,
          (string)$oodle->body,
          (string)$oodle->url,
          (string)$oodle->category->id,
          (string)$oodle->category->name,
          (string)$oodle->source->id,
          (string)$oodle->source->name,
          (string)$oodle->source->logo_src,
          (string)$oodle->location->citycode,
          (string)$oodle->location->name,
          (string)$oodle->location->state,
          (string)$oodle->location->country,
          (string)$oodle->location->latitude,
          (string)$oodle->location->longitude,
          join("\n", $image_gallery)
        );
        
        $content = str_replace($content_search_tags, $content_replace_tags, $content);

        $post_data = array(
          "uid" => md5($oodle->id),
          "title" => $oodle->title,
          "content" => $content,
          "featured_image" => ( isset($featured_image_tt_index) && $featured_image_tt_index !== FALSE ) ? (string)$content_replace_tags[$featured_image_tt_index] : "",
        );
        array_push($output, $post_data);
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_oodle_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_oodle_module_template_installed") != "Yes") {
    $wpt->set_template("oodle", $wpt_oodle_default_module_template);
    update_option("wpt_oodle_module_template_installed", "Yes");
  }
  if(get_option("wpt_oodle_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_oodle_default_post_template);
    update_option("wpt_oodle_post_template_installed", "Yes");
  }
}
?>
