<?php
include_once ( WPT_PLUGIN_DIR."/includes/libs/phpquery.php" );

function wpt_pressrelease_options_admin($self) {
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_pressrelease_response($params) {
  libxml_use_internal_errors(true);

  ksort($params);

  $request_query = array();
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);
  
  $request = "http://www.prweb.com/Search.aspx?".$request_query;

  $response = wpt_get_response( $request, "PressRelease" );
  $_response = phpQuery::newDocument($response);
  $output = array();
  $_pressrelease_rows = $_response->find("#releases")->find("div.release");
  foreach( $_pressrelease_rows as $_pressrelease_row ) {
    $output[] = pq($_pressrelease_row)->find("div.release-content:first h3:first a:first")->attr("href");
  }
  return $output;
}

function wpt_single_pressrelease_response($url) {
  $response = wpt_get_response( $url, "PressRelease" );
  $_pressrelease_data = phpQuery::newDocument($response);
  $output = array();
  $date_posted = trim($_pressrelease_data->find(".release:first .content .floatLeft p.releaseDateline")->text());
  $date_posted = str_replace( array("(PRWEB)"), array(""), $date_posted );
  $output['date_posted'] = trim($date_posted);
  $_pressrelease_data->find(".release:first .content .floatLeft p.releaseDateline")->remove();
  $_pressrelease_data->find(".release:first .content .floatLeft .footershare")->remove();
  $_pressrelease_data->find(".release:first .content .floatLeft div.mediaBox")->remove();
  $output['content'] = $_pressrelease_data->find(".release:first .content .floatLeft")->html();
  $output['subtitle'] = $_pressrelease_data->find(".release:first .content h2.subtitle")->html();
  $output['title'] = $_pressrelease_data->find(".release:first .content h1.title:first")->html();
  $output = (object)$output;
  return $output;
}

function wpt_pressrelease_post($params) {
  global $wpdb, $wpt;
  
  extract($params);
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));
  
  if( isset($featured_image_module) && $featured_image_module == "{".$this_module_name."-fi}" ) {
    $featured_image_tt_index = array_search( "{".$featured_image_module_tag."}", $wpt_pressrelease_template_tags );
  }
  
  if($keywords == "") {
    return send_module_errors("PressRelease", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/25 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 25 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'pressrelease'");
  if($template == false || empty($template)) {
    return send_module_errors("PressRelease", "[Keywords Empty] Module Template was not found.");
  }

  $options = $wpt->options;

  $output = array();

  for($i = 0; $i < $count; $i++) {
    $pressrelease_response = wpt_pressrelease_response(array(
                                        "Search-releases" => urlencode($keywords),
                                        "start" => $page,
                                      ));
    if(!empty($pressrelease_response["error"]))
      return $pressrelease_response;
    $count_this = ($count <= 25) ? $count : 25;
    
    $counter2 = 0;
    $counter1 = 1;

    if (!$pressrelease_response) {
      return send_module_errors("PressRelease", "[Request Failed] API request failed." );
    }

    if ( (count($pressrelease_response) < 1)) {
      return send_module_errors("PressRelease", "[Content Empty] No pressrelease found for this keyword.");
    }
    
    foreach($pressrelease_response as $pressrelease_url) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;

      if ($counter2<$count_this) {
        $content = $template;
        $pressrelease_content = wpt_single_pressrelease_response($pressrelease_url);
        if( isset( $pressrelease_content->title ) ) {
          
          $content_search_tags = $wpt_pressrelease_template_tags;
          
          $content_replace_tags = array(
            $keywords,
            (string)$pressrelease_content->title,
            (string)$pressrelease_content->subtitle,
            (string)$pressrelease_content->content,
            (string)$pressrelease_content->date_posted,
          );
          
          $content = str_replace($content_search_tags, $content_replace_tags, $content);

          $post_data = array(
            "uid" => md5($pressrelease_url),
            "title" => $pressrelease_content->title,
            "content" => $content,
            "featured_image" => ( isset($featured_image_tt_index) && $featured_image_tt_index !== FALSE ) ? (string)$content_replace_tags[$featured_image_tt_index] : "",
          );
          array_push($output, $post_data);
        }
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_pressrelease_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_pressrelease_module_template_installed") != "Yes") {
    $wpt->set_template("pressrelease", $wpt_pressrelease_default_module_template);
    update_option("wpt_pressrelease_module_template_installed", "Yes");
  }
  if(get_option("wpt_pressrelease_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_pressrelease_default_post_template);
    update_option("wpt_pressrelease_post_template_installed", "Yes");
  }
}
?>
