<?php
include_once ( ABSPATH.WPINC."/feed.php" );
include_once ( WPT_PLUGIN_DIR."/includes/libs/phpquery.php" );

function wpt_rss_options_admin($self) {
  include(dirname(__file__)."/wptm-options.php");
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_rss_campaign_type($self, $campaign_data) {
  global $wpt;
  include(dirname(__file__)."/wptm-options.php");
  include_once(dirname(__file__)."/templates/campaign-type.php");
}

function wpt_rss_response($params) {
  $options = get_option("wpt_options");
  $options = is_array($options) ? $options : unserialize($options);

  $request = $params['rss_url'];

  $feed_data = fetch_feed($request);
  if (!$feed_data || empty( $feed_data ) || $feed_data === false ) {
    return send_module_errors("RSS", "[Loading Error] Failed to load RSS Data for the RSS URL &lsquo;{$request}&rsquo;." );
  }
  if( !empty( $feed_data ) )
    return $feed_data;
  else 
    return send_module_errors("RSS", "[Empty Output] The output was empty." );
}

function wpt_rss_post($params) {
  global $wpdb, $wpt;

  extract($params);
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));

  if($keywords == "") {
    return send_module_errors("RSS", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/10 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 10 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'rss'");
  if($template == false || empty($template)) {
    return send_module_errors("RSS", "[Keywords Empty] Module Template was not found.");
  }

  $output = array();
  
  $content = $template;
  
  for($i = 0; $i < $count; $i++) {
    $response_params = array(
                            "rss_url" => $keywords,
                            );

    $rss_xml_response = wpt_rss_response($response_params);

    if(empty($rss_xml_response))
      return send_module_errors("RSS", "[Empty Output] The output was empty." );
    $count_this = ($count <= 10) ? $count : 10;
    
    $counter2 = 0;
    $counter1 = 1;
    if( get_class( $rss_xml_response ) != "SimplePie" ) {
      return send_module_errors("RSS", "[Empty Output] RSS Module cannot be used with keywords." );
    }
    $feed_items = $rss_xml_response->get_items($start, $per_page);
    foreach($feed_items as $item) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;

      if ($counter2<$count_this) {
        $content_search_tags = $wpt_rss_template_tags;
        
        $content_replace_tags = array(
          $keywords,
          (string)$item->get_description(),
          (string)$item->get_title(),
          (string)$item->get_link(),
          (string)$item->get_date(),
          $item->get_id(true),
        );
        
        $content = str_replace($content_search_tags, $content_replace_tags, $content);

        $post_data = array(
          "uid" => md5((string)$item->get_id(true)),
          "title" => (string)$item->get_title(),
          "content" => $content,
        );
        array_push($output, $post_data);
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_rss_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_rss_module_template_installed") != "Yes") {
    $wpt->set_template("rss", $wpt_rss_default_module_template);
    update_option("wpt_rss_module_template_installed", "Yes");
  }
  if(get_option("wpt_rss_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_rss_default_post_template);
    update_option("wpt_rss_post_template_installed", "Yes");
  }
}

?>
