<?php

function wpt_yahooanswers_options_admin($self) {
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_yahooanswers_comments($question_id) {
  $options = get_option("wpt_options");
  $options = is_array($options) ? $options : unserialize($options);
  
  $params = array();
  
  $default_params = array(
    "appid" => $options['wpt_yahooanswers_appid'],
    "question_id" => $question_id,
  );

  $params = array_merge($params, $default_params);
  ksort($params);

  $request_query = array();
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);
  
  $request = "http://answers.yahooapis.com/AnswersService/V1/getQuestion?".$request_query;

  $question_xml_response = wpt_get_xml_response( $request, "YahooAnswers" );
  
  if (!$question_xml_response) {
    return send_module_errors("YahooAnswers", "[Request Failed] API request failed." );
  }

  if ($question_xml_response->Message) {
    return send_module_errors("YahooAnswers", "[Request Failed] API request failed with the following error: ".$question_xml_response->Message );
  }
  
  $comments = array();
  
  if( count($question_xml_response->Question->Answers->Answer) > 0 ) {
    foreach( $question_xml_response->Question->Answers->Answer as $answer ) {
      $comment = array(
        "author" => (string)$answer->UserNick,
        "author_email" => (string)$answer->UserId."@yahoo.com",
        "author_url" => "",
        "author_IP" => "",
        "date" => get_date_from_gmt((string)$answer->Date),
        "date_gmt" => (string)$answer->Date,
        "content" => (string)$answer->Content,
      );
      $comments[] = (object)$comment;
    }
  }
  return $comments;
}

function wpt_yahooanswers_response($params) {
  $options = get_option("wpt_options");
  $options = is_array($options) ? $options : unserialize($options);

  $default_params = array(
    "appid" => $options['wpt_yahooanswers_appid'],
    "results" => "10",
    "language" => "en",
  );

  $params = array_merge($params, $default_params);
  ksort($params);

  $request_query = array();
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);
  
  $request = "http://answers.yahooapis.com/AnswersService/V1/questionSearch?".$request_query;

  return wpt_get_xml_response( $request, "YahooAnswers" );
}

function wpt_yahooanswers_post($params) {
  global $wpdb, $wpt;

  extract($params);
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));
  
  if( isset($featured_image_module) && $featured_image_module == "{".$this_module_name."-fi}" ) {
    $featured_image_tt_index = array_search( "{".$featured_image_module_tag."}", $wpt_yahooanswers_template_tags );
  }

  if($keywords == "") {
    return send_module_errors("YahooAnswers", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/10 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 10 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'yahooanswers'");
  if($template == false || empty($template)) {
    return send_module_errors("YahooAnswers", "[Keywords Empty] Module Template was not found.");
  }

  $options = $wpt->options;

  $output = array();

  for($i = 0; $i < $count; $i++) {
    $yahooanswers_xml_response = wpt_yahooanswers_response(array(
                                        "query" => urlencode($keywords),
                                        "start" => $start+1,
                                      ));

    if(!empty($yahooanswers_xml_response["error"]))
      return $yahooanswers_xml_response;
    $count_this = ($count <= 10) ? $count : 10;
    
    $counter2 = 0;
    $counter1 = 1;

    if (!$yahooanswers_xml_response) {
      return send_module_errors("YahooAnswers", "[Request Failed] API request failed." );
    }

    if ($yahooanswers_xml_response->Message) {
      return send_module_errors("YahooAnswers", "[Request Failed] API request failed with the following error: ".$yahooanswers_xml_response->Message );
    }

    if ( (count($yahooanswers_xml_response->Question) < 1) || !$yahooanswers_xml_response->Question) {
      return send_module_errors("YahooAnswers", "[Content Empty] No answers found for this keyword.");
    }
    
    foreach($yahooanswers_xml_response->Question as $question) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;
      if ($counter2<$count_this) {
        $content = $template;

        $content_search_tags = $wpt_yahooanswers_template_tags;
        
        $content_replace_tags = array(
          $keywords,
          (string)$question->Subject,
          (string)$question->Content,
          date_i18n("jS F y", strtotime($question->Date)),
          (string)$question->Timestamp,
          (string)$question->Link,
          (string)$question->Category,
          (string)$question->UserId,
          (string)$question->UserNick,
          (string)$question->UserPhotoURL,
          (string)$question->NumAnswers,
          (string)$question->NumComments,
          (string)$question->ChosenAnswer,
          (string)$question->ChosenAnswererId,
          (string)$question->ChosenAnswererNick,
          date_i18n("jS F y", (double)$question->ChosenAnswerTimestamp),
          date_i18n("jS F y", (double)$question->ChosenAnswerAwardTimestamp),
        );
        $question_id = (string)$question["id"];
        $post_date = ($wpt->options['wpt_yahooanswers_post_as_archives'] == "Yes") ? $question->Date : date_i18n("Y-m-d H:i:s", time() - rand(0,3600));
        
        $content = str_replace($content_search_tags, $content_replace_tags, $content);

        $post_data = array(
          "uid" => md5((string)$question_id),
          "title" => (string)$question->Subject,
          "content" => $content,
          "featured_image" => ( isset($featured_image_tt_index) && $featured_image_tt_index !== FALSE ) ? (string)$content_replace_tags[$featured_image_tt_index] : "",
          "comments" => wpt_yahooanswers_comments($question_id),
          "post_date" => $post_date,
        );

        array_push($output, $post_data);
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_yahooanswers_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_yahooanswers_module_template_installed") != "Yes") {
    $wpt->set_template("yahooanswers", $wpt_yahooanswers_default_module_template);
    update_option("wpt_yahooanswers_module_template_installed", "Yes");
  }
  if(get_option("wpt_yahooanswers_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_yahooanswers_default_post_template);
    update_option("wpt_yahooanswers_post_template_installed", "Yes");
  }
}
?>
