<?php

function wpt_yahoonews_options_admin($self) {
  include_once(dirname(__file__)."/templates/admin-options.php");
}

function wpt_yahoonews_response($params) {
  $options = get_option("wpt_options");
  $options = is_array($options) ? $options : unserialize($options);

  $default_params = array(
    "appid" => $options['wpt_yahoonews_appid'],
    "results" => "10",
    "language" => "en",
  );

  $params = array_merge($params, $default_params);
  ksort($params);

  $request_query = array();
  foreach ($params as $param=>$value) {
    $request_query[] = $param."=".$value;
  }
  $request_query = implode("&", $request_query);
  
  $request = "http://search.yahooapis.com/NewsSearchService/V1/newsSearch?".$request_query;

  return wpt_get_xml_response( $request, "YahooNews" );
}

function wpt_yahoonews_post($params) {
  global $wpdb, $wpt;

  extract($params);
  include(dirname(__file__)."/wptm-options.php");
  $this_module_name = preg_replace("/^wptm\-/", "", basename(realpath(dirname(__FILE__))));
  
  if( isset($featured_image_module) && $featured_image_module == "{".$this_module_name."-fi}" ) {
    $featured_image_tt_index = array_search( "{".$featured_image_module_tag."}", $wpt_yahoonews_template_tags );
  }

  if($keywords == "") {
    return send_module_errors("YahooNews", "[Keywords Empty] No keyword specified.");
  }
  
  $page = floor( $start/10 ) + 1;
  $last_post_number = $start - ( ($page - 1) * 10 );

  $template = $wpdb->get_var("SELECT content FROM {$wpt->db->table_name_templates} WHERE template_type = 'yahoonews'");
  if($template == false || empty($template)) {
    return send_module_errors("YahooNews", "[Keywords Empty] Module Template was not found.");
  }

  $options = $wpt->options;

  $output = array();

  for($i = 0; $i < $count; $i++) {
    $yahoonews_xml_response = wpt_yahoonews_response(array(
                                        "query" => urlencode($keywords),
                                        "start" => $start+1,
                                      ));

    if(!empty($yahoonews_xml_response["error"]))
      return $yahoonews_xml_response;
    $count_this = ($count <= 10) ? $count : 10;
    
    $counter2 = 0;
    $counter1 = 1;

    if (!$yahoonews_xml_response) {
      return send_module_errors("YahooNews", "[Request Failed] API request failed." );
    }

    if ($yahoonews_xml_response->Message) {
      return send_module_errors("YahooNews", "[Request Failed] API request failed with the following error: ".$yahoonews_xml_response->Message );
    }

    if ( (count($yahoonews_xml_response->Result) < 1) || !$yahoonews_xml_response->Result) {
      return send_module_errors("YahooNews", "[Content Empty] No news found for this keyword.");
    }
    
    foreach($yahoonews_xml_response->Result as $yahoonews) {
      if( $counter1 < $last_post_number ) {
        $counter1++;
        continue;
      }
      $counter1++;
      if ($counter2<$count_this) {
        $content = $template;

        $content_search_tags = $wpt_yahoonews_template_tags;
        
        $content_replace_tags = array(
          $keywords,
          (string)$yahoonews->Title,
          (string)$yahoonews->Summary,
          (string)$yahoonews->Url,
          (string)$yahoonews->ClickUrl,
          (string)$yahoonews->NewsSource,
          (string)$yahoonews->NewsSourceUrl,
          (string)$yahoonews->Language,
          date_i18n("jS F y", (double)$yahoonews->PublishDate),
          date_i18n("jS F y", (double)$yahoonews->ModificationDate),
          date_i18n("jS F y", (double)$yahoonews->PublishDate),
          date_i18n("jS F y", (double)$yahoonews->ModificationDate),
        );
        
        $content = str_replace($content_search_tags, $content_replace_tags, $content);

        $post_data = array(
          "uid" => md5((string)$yahoonews->ClickUrl),
          "title" => (string)$yahoonews->Title,
          "content" => $content,
          "featured_image" => ( isset($featured_image_tt_index) && $featured_image_tt_index !== FALSE ) ? (string)$content_replace_tags[$featured_image_tt_index] : "",
        );

        array_push($output, $post_data);
        $counter2++;
      }
    }
    $page++;
    $last_post_number = 0;
  }
  return $output;
}

function wpt_yahoonews_init() {
  global $wpdb, $wpt;
  include(dirname(__file__)."/wptm-options.php");
  if(get_option("wpt_yahoonews_module_template_installed") != "Yes") {
    $wpt->set_template("yahoonews", $wpt_yahoonews_default_module_template);
    update_option("wpt_yahoonews_module_template_installed", "Yes");
  }
  if(get_option("wpt_yahoonews_post_template_installed") != "Yes") {
    $wpt->set_template("post", $wpt_yahoonews_default_post_template);
    update_option("wpt_yahoonews_post_template_installed", "Yes");
  }
}
?>
