jQuery.fn.wp_display_notices = function(options) {
  options = jQuery.extend({
                              message_item: "",
                              default_class: "wpt-display-notices"
                          }, options);
  var $this_form = this;
  if(options.message_item != "") {
    var $message_item = jQuery(options.message_item);
    $this_form.parent().find(".wpt-display-notices").remove();
    $this_form.before($message_item);
  }
}
var $loader = jQuery('<div class="wpt-loader"><table>\
  <tr>\
    <td><span class="wpt-loading-icon"></span><span class="wpt-loading-text">Loading...</span></td>\
  </tr>\
</table></div>');

function reindex_campaign_templates() {
  jQuery(".post-template-section").each(function(i){
    jQuery(this).find(":regex(id,_[\\d]+_$)").each(function(){
      var new_id = jQuery(this).attr("id").replace(/(.*)_([\d]+)_$/, "$1_"+i+"_");
      jQuery(this).attr("id", new_id);
    });
    jQuery(this).find(":regex(for, _[\\d]+_$)").each(function(){
      var new_for = jQuery(this).attr("for").replace(/(.*)_([\d]+)_$/, "$1_"+i+"_");
      jQuery(this).attr("for", new_for);
    });
    jQuery(this).find(":regex(rev, _[\\d]+_$)").each(function(){
      var new_rev = jQuery(this).attr("rev").replace(/(.*)_([\d]+)_$/, "$1_"+i+"_");
      jQuery(this).attr("rev", new_rev);
    });
    jQuery(this).find(":regex(name, \[[\\d]+\])").each(function(){
      var new_name = jQuery(this).attr("name").replace(/(.*)\[([\d]+)\](.*)/, "$1["+i+"]$3");
      jQuery(this).attr("name", new_name);
    });
    var this_id = jQuery(this).attr("id");
    var new_this_id = this_id.replace(/(.*)_([\d]+)_$/, "$1_"+i+"_");
    jQuery(this).attr("id", new_this_id);
    jQuery(this).find(".post-template-section-header span.template-header-text").text("Post Templates "+(i + 1));
  });
}

function reindex_replacement_keywords() {
  jQuery(".keyword-replacment-table").find("tr.input-row").each(function(i){
    jQuery(this).find(":regex(name, \[[\\d]+\])").each(function(){
      var new_name = jQuery(this).attr("name").replace(/(.*)\[([\d]+)\](.*)/, "$1["+i+"]$3");
      jQuery(this).attr("name", new_name);
    });
  });
}

function get_sections_state() {
  var visible_section = window.location.hash.toString();
  if(jQuery.cookie) {
    if( jQuery.cookie("wpt_section_tabs_cookie") == null ) {
      var closed_sections = new Array("wpt-create-kw-campaign", "wpt-create-bn-campaign", "wpt-create-rss-campaign", "wpt-main-settings", "wpt-amazon-settings", "wpt-articles-settings", "wpt-clickbank-settings", "wpt-coupons-settings", "wpt-ebay-settings", "wpt-eventful-settings", "wpt-flickr-settings", "wpt-heyzap-settings", "wpt-imdb-settings", "wpt-itunes-settings", "wpt-jobs-settings", "wpt-linkshare-settings", "wpt-musixmatch-settings", "wpt-yahoonews-settings", "wpt-oodle-settings", "wpt-pressrelease-settings", "wpt-recipes-settings", "wpt-rss-settings", "wpt-twitter-settings", "wpt-youtube-settings", "wpt-yahooanswers-settings");
      jQuery.cookie("wpt_section_tabs_cookie", closed_sections.join(","));
    }
  }
  if(visible_section && jQuery(visible_section).length > 0  ) {
    jQuery(".wpt-section").each(function(){
      jQuery(this).find("h2.toggle-header").addClass('closed');
      jQuery(this).find(".section-content").hide();
    });
    jQuery(visible_section).find("h2.toggle-header").removeClass('closed');
    jQuery(visible_section).find(".section-content").show();
  } else {
    if(jQuery.cookie) {
      var closed_sections = jQuery.cookie("wpt_section_tabs_cookie");
      closed_sections = (closed_sections != null) ? closed_sections.split(",") : new Array();
      jQuery(closed_sections).each(function(i, v){
        if(v != "" && jQuery( "#"+v ).length > 0) {
          jQuery("#"+v).find("h2.toggle-header").addClass('closed');
          jQuery("#"+v).find(".section-content").hide();
        }
      });
    }
  }
}

jQuery(function() {
  get_sections_state();
  jQuery(".add-replacement-keywords").live("click", function(){
    var $new_row = jQuery(this).parents("tr.input-row:first").clone();
    var new_index = jQuery(this).parents("table:first").find("tr.input-row").length;
    $new_row.find(":regex(name, \[[\\d]+\])").each(function(){
      var new_name = jQuery(this).attr("name").replace(/(.*)\[([\d]+)\](.*)/, "$1["+new_index+"]$3");
      jQuery(this).attr("name", new_name);
      jQuery(this).val("");
    });
    jQuery(this).hide();
    jQuery(this).parents("tr.input-row:first").after($new_row);
  });
  jQuery(".remove-replacement-keywords").live("click", function(){
    var $this_table = jQuery(this).parents("table:first");
    var $this_row = jQuery(this).parents("tr:first");
    if($this_table.find("tr.input-row").length < 2) {
      alert("The last row cannot be removed!");
      return;
    } else {
      $this_row.remove();
    }
    $this_table.find("tr.input-row:last").find(".add-replacement-keywords").show();
    reindex_replacement_keywords();
  });
  jQuery(".add-post-template").live("click", function(){
    var $post_template_section = jQuery(this).parents(".section-content").find(".post-template-section:last").clone();
    var post_template_section_index = jQuery(".post-template-section:last").attr("id").replace(/(.*)_([\d]+)_$/, "$2");
    new_post_template_section_index = Number(post_template_section_index) + 1;
    $post_template_section.find("textarea, input[type='text']").val("");
    $post_template_section.find(":regex(id,_[\\d]+_$)").each(function(){
      var new_id = jQuery(this).attr("id").replace(/(.*)_([\d]+)_$/, "$1_"+new_post_template_section_index+"_");
      jQuery(this).attr("id", new_id);
    });
    $post_template_section.find(":regex(for, _[\\d]+_$)").each(function(){
      var new_for = jQuery(this).attr("for").replace(/(.*)_([\d]+)_$/, "$1_"+new_post_template_section_index+"_");
      jQuery(this).attr("for", new_for);
    });
    $post_template_section.find(":regex(rev, _[\\d]+_$)").each(function(){
      var new_rev = jQuery(this).attr("rev").replace(/(.*)_([\d]+)_$/, "$1_"+new_post_template_section_index+"_");
      jQuery(this).attr("rev", new_rev);
    });
    $post_template_section.find(":regex(name, \[[\\d]+\])").each(function(){
      var new_name = jQuery(this).attr("name").replace(/(.*)\[([\d]+)\](.*)/, "$1["+new_post_template_section_index+"]$3");
      jQuery(this).attr("name", new_name);
    });
    var this_id = $post_template_section.attr("id");
    var new_this_id = this_id.replace(/(.*)_([\d]+)_$/, "$1_"+new_post_template_section_index+"_");
    $post_template_section.attr("id", new_this_id);
    $post_template_section.find(".post-template-section-header span.template-header-text").text("Post Templates "+(new_post_template_section_index + 1));
    jQuery(this).parents(".row:first").before($post_template_section);
  });
  
  jQuery(".delete-campaign-post-template").live("click", function() {
    if(jQuery(this).parents(".wpt-section").find(".post-template-section").length < 2) {
      alert("The last post template cannot be remove.");
    } else {
      var c = confirm("Remove this post template from the campaign?");
      if(c) {
        jQuery(this).parents(".post-template-section").remove();
      }
    }
    reindex_campaign_templates();
  });
  
  jQuery(".delete-post-template").click(function(e){
    e.stopPropagation();
    var c = confirm("Remove this post template?");
    if(!c) {
      return;
    }
    var $self = jQuery(this);
    var template_id = $self.attr("rel");
    var $local_loader = $loader.clone();
    jQuery(".wpt-section:first").before($local_loader);
    position_loader($local_loader);
    jQuery.ajax({
      url: ajaxurl,
      type: 'POST',
      data: {
        action: 'wpt_submit_process',
        form_key: 'delete_template',
        wpt_delete_template: true,
        template_id: template_id,
        ajax: true
      },
      dataType: "json",
      success: function (response_data) {
        if(response_data.data == "Success") {
          $self.parents(".wpt-section:first").fadeOut(500, function(){
            jQuery(this).remove();
          });
        } else {
          alert("Something went wrong!");
        }
        $local_loader.remove();
      }
    });
  });
  
  jQuery(".wpt-load-post-template").live("click", function(){
    var $form = jQuery(this).parents("form:first");
    var post_template_index = jQuery(this).attr("id").replace(/(.*)_([\d]+)_$/, "$2");
    var template_id = jQuery(this).prev(".wpt-post-templates-base-template").val();
    if( template_id == "" || isNaN(template_id) ) {
      alert("Please select a post template to load.");
    } else {
      var $local_loader = $loader.clone();
      jQuery(".wpt-section:first").before($local_loader);
      position_loader($local_loader);
      jQuery.ajax({
        url: ajaxurl,
        type: 'POST',
        data: {
          action: 'wpt_submit_process',
          form_key: 'load_post_template',
          wpt_load_post_template: true,
          template_id: template_id,
          post_template_index: post_template_index,
          ajax: true
        },
        dataType: 'json',
        success: function (response_data) {
          $form.deserialize(response_data.data, {overwrite: false});
          $local_loader.remove();
        }
      })
    }
  });
  jQuery(".wpt-section h2.toggle-header").live("click", function() {
    var $wpt_section = jQuery(this).parents(".wpt-section:first");
    var wpt_section_id = $wpt_section.attr("id");
    if(jQuery.cookie) {
      var closed_sections = jQuery.cookie("wpt_section_tabs_cookie");
      closed_sections = (closed_sections != null) ? closed_sections.split(",") : new Array();
      closed_sections = jQuery.grep(closed_sections, function(value) {
                        return value != wpt_section_id;
                        });
      jQuery.unique(closed_sections);
    }
    var $wpt_section_content = jQuery(this).parents(".wpt-section:first").find(".section-content");
    if($wpt_section_content.is(":visible")) {
      $wpt_section_content.slideUp();
      jQuery(this).addClass("closed");
      if(jQuery.cookie) closed_sections.push(wpt_section_id);
    } else {
      $wpt_section_content.slideDown();
      jQuery(this).removeClass("closed");
    }
    if(jQuery.cookie) jQuery.cookie("wpt_section_tabs_cookie", closed_sections.join(","));
  });
  
  jQuery("form.wpt-ajaxified").submit(function() {
    return false;
  });
  function position_loader($loader) {
    var window_height = jQuery(window).height();
    var loader_height = $loader.outerHeight(true);
    var loader_top = jQuery(window).scrollTop() + (window_height - loader_height)/2;
    $loader.offset({ top: loader_top });
  }
  
  jQuery(window).bind("scroll resize",function(){
    position_loader(jQuery(".wpt-loader"));
  });
  
  jQuery(".add-template-tag").live("click", function() {
    var $textarea = jQuery("#"+jQuery(this).attr("rev"));
    var template_tag = jQuery(this).attr("rel");
    $textarea.insertAtCaret(template_tag);
  });
  
  jQuery(".wpt-section input.wpt-buttons-reset").live("click", function(){
    if(!jQuery(this).hasClass("wpt-reset-settings")) 
    jQuery(this).parents(".wpt-section:first").find("h2.toggle-header").trigger("click");
  })
  
  jQuery("form.wpt-ajaxified input:submit").live("click", function(){
    if(jQuery(this).hasClass("wpt-reset-settings")) {
      var c=confirm("Are you sure you want to reset settings to default?");
      if(!c) return false;
    }
    var $form = jQuery(this).parents("form:first");
    var $local_loader = $loader.clone();
    jQuery(".wpt-section:first").before($local_loader);
    position_loader($local_loader);
    var form_submission_data = (jQuery(this).attr("name")) ? "&"+jQuery(this).attr("name")+"="+jQuery(this).val() : "";
    var form_data = $form.serialize()+"&ajax=true"+form_submission_data;
    jQuery.ajax({
      url: ajaxurl,
      type: 'POST',
      data: form_data,
      dataType: "json",
      success: function (response_data) {
        $form.wp_display_notices({
          message_item: response_data.notice
        });
        if( (typeof(response_data.data) == "object") && !jQuery.isArray(response_data.data) ) {
          $form.deserialize(response_data.data);
          $form.find(".jQTagBox").trigger("reloadTagBox");
        }
        $local_loader.remove();
      }
    });
    return false;
  });
  
  
  
  if(jQuery().tagBox) {
    jQuery("textarea.tag-box").tagBox({
      separator: ';',
      confirmRemoval: true,
      confirmRemovalText: "Remove word from list?",
      completeOnBlur: true,
      tagButtonClassName: "wpt-buttons",
      tagButtonTitle: "Add Word"
    });
    jQuery("textarea.tag-box-nl").tagBox({
      separator: '\n',
      confirmRemoval: true,
      confirmRemovalText: "Remove keyword from list?",
      completeOnBlur: true,
      tagButtonClassName: "wpt-buttons",
      tagButtonTitle: "Add Keyword"
    });
    jQuery("textarea.tag-box-nl-bn").tagBox({
      separator: '\n',
      confirmRemoval: true,
      confirmRemovalText: "Remove BrowseNode from list?",
      completeOnBlur: true,
      tagButtonClassName: "wpt-buttons",
      tagButtonTitle: "Add BrowseNode",
      tagInputClassName: "wpt-browse-node-input"
    });
    /*jQuery("textarea.tag-box-categories").tagBox({
      separator: '\n',
      confirmRemoval: true,
      confirmRemovalText: "Remove category from list?",
      completeOnBlur: true,
      tagButtonClassName: "wpt-buttons",
      tagButtonTitle: "Add Category"
    });*/
    jQuery("textarea.tag-dropdown-box").tagBox({
      separator: ';',
      confirmRemoval: true,
      confirmRemovalText: "Remove user from list?",
      completeOnBlur: true,
      tagButtonClassName: "wpt-buttons",
      tagButtonTitle: "Add User",
      enable_dropdown: true,
      dropdown_source: function() {
        var options = new Array();
        jQuery("#wp-users-list-for-authorid").find("select:first option").each(function() {
          options.push('"'+jQuery(this).attr("value")+'":"'+jQuery(this).text()+'"');
        });
        return '{'+options.join(",")+'}';
      }
    });
  }
});
