jQuery.expr[':'].regex = function(elem, index, match) {
    var matchParams = match[3].split(','),
        validLabels = /^(data|css):/,
        attr = {
            method: matchParams[0].match(validLabels) ? 
                        matchParams[0].split(':')[0] : 'attr',
            property: matchParams.shift().replace(validLabels,'')
        },
        regexFlags = 'ig',
        regex = new RegExp(matchParams.join('').replace(/^\s+|\s+$/g,''), regexFlags);
    return regex.test(jQuery(elem)[attr.method](attr.property));
}

jQuery.fn.extend({
  insertAtCaret: function(myValue){
    return this.each(function(i) {
      if (document.selection) {
        this.focus();
        sel = document.selection.createRange();
        sel.text = myValue;
        this.focus();
      }
      else if (this.selectionStart || this.selectionStart == '0') {
        var startPos = this.selectionStart;
        var endPos = this.selectionEnd;
        var scrollTop = this.scrollTop;
        this.value = this.value.substring(0, startPos)+myValue+this.value.substring(endPos,this.value.length);
        this.focus();
        this.selectionStart = startPos + myValue.length;
        this.selectionEnd = startPos + myValue.length;
        this.scrollTop = scrollTop;
      } else {
        this.value += myValue;
        this.focus();
      }
    })
  },
  multi_options: function (plugin_options) {
    var defaults = {
      t_separator: '|',
      v_separator: ',',
      parent_div_class: '',
      input_div_class: ''
    };
    plugin_options = jQuery.extend( defaults, plugin_options );
    var $element = this;
    var this_id = $element.attr("id");
    this_id = (this_id) ? this_id : "multi-options-"+ Math.round( Math.random() * 10000 ) ;
    if( !$element.attr("title") ) return false;
    var options = $element.attr("title").split(plugin_options.t_separator);
    var selected_options = $element.val().split(plugin_options.v_separator);
    var $checkboxes = jQuery('<div id="'+this_id+'_options"'+( plugin_options.parent_div_class ? ' class="'+plugin_options.parent_div_class+'"' : '' )+'></div>');
    $element.hide();
    jQuery.each(options, function(i, v){
      var values = v.match(/([^\{]+)\{([^\}]+)\}/);
      if( !values || values == null || values.length < 3 ) {
        var option_value = values;
        var option_text = values;
      } else {
        var option_value = values[2];
        var option_text = values[1];
      }
      var options = '<div'+( plugin_options.input_div_class ? ' class="'+plugin_options.input_div_class+'"' : '' )+'><input type="checkbox" name="'+this_id+'_options" id="'+this_id+'-'+i+'" value="'+option_value+'"'+(( jQuery.inArray(option_value, selected_options) != -1 ) ? ' checked="checked"' : '')+' /\> <label for="'+this_id+'-'+i+'" class="inline-label">'+option_text+'</label></div>';
      $checkboxes.append(options);
    });
    $checkboxes.find(":checkbox").change(function(){
      var selected_options = new Array();
      $checkboxes.find(":checkbox:checked").each(function(){
        selected_options.push(jQuery(this).val());
      });
      jQuery("#"+this_id).val(selected_options.join(plugin_options.v_separator));
    })
    jQuery("#"+this_id).after($checkboxes);
  }
});

