<?php
/*
  Plugin Name: WP Turbo
  Plugin URI: http://wpturbo.com
  Version: 1.3
  Description: Premium WordPress Auto-post generator plugin
  Author: Kooc Media
  Author URI: http://kooc.co.uk
*/

# <constant_definitions>
!defined('WP_CONTENT_URL') ? define('WP_CONTENT_URL', get_option('siteurl') . '/wp-content') : WP_CONTENT_URL;
define('WPT_PLUGIN_URL', WP_PLUGIN_URL.'/'.plugin_basename( dirname(__FILE__) ).'/' );
define('WPT_PLUGIN_DIR', dirname(__file__));
define('WPT_MODULES_DIR', WPT_PLUGIN_DIR.'/modules');
define('WPT_SAVE_IMAGE_URL', WPT_PLUGIN_URL . "images" );
define('WPT_SAVE_IMAGE_PATH', ABSPATH . "wp-content/plugins/". plugin_basename( dirname(__FILE__) )."/images" );
define('WPT_VERSION', "1.0" );
define('WPT_ITEMS_PER_PAGE', 10);
define('WPT_CLOAKER_URL', WPT_PLUGIN_URL.'wpt-cloak.php' );
define('WPT_EMAIL', "seabugzpress@coded95ocean.com");
# </constant_definitions>

# <includes>
include_once(WPT_PLUGIN_DIR."/includes/libs/class.autokeyword.php");
include_once(WPT_PLUGIN_DIR."/includes/wpt-libs.php");
include_once(WPT_PLUGIN_DIR."/includes/wpt-core.php");
# </includes>

# <plugin_activation>
register_activation_hook( __file__ , array(&$wpt,'activate'));
# </plugin_activation>

#<scheduled_posting_hook>
add_action("wpt_events_hook", 'wpt_posts_bot');
#</scheduled_posting_hook>

# <plugin_filters>
add_filter('cron_schedules', array(&$wpt,'get_schedules'));
# </plugin_filters>

# <plugin_hooks>
add_action('admin_menu', array(&$wpt,'register_admin_menu'));
$wpt->init_admin_interface();
# </plugin_hooks>

if($wpt->options['wpt_cloak_affiliate_links'] == "Yes") {
  function wpt_cloak_affiliate_links_rewriter($matches){
    global $post, $wpdb, $wpt;
    $url = $matches[3];
    $cloak_pattern_found = false;
    foreach( $wpt->cloak_patterns as $cloak_pattern ) {
      if( preg_match('/'.$cloak_pattern.'/i', $url) ){
        $cloak_pattern_found = true;
        break;
      }
    }
    if( $cloak_pattern_found ) {
      $uid = uniqid();
      $link_exists = $wpdb->get_var( "SELECT COUNT(*) FROM {$wpt->db->table_name_link_cloak} WHERE link LIKE '$url'" );
      if( $link_exists < 1 ) {
        $wpdb->insert( $wpt->db->table_name_link_cloak, array( 'uid' => $uid, 'link' => $url, 'created_at' => current_time('mysql') ) );
      } else {
        $uid = $wpdb->get_var( "SELECT uid FROM  {$wpt->db->table_name_link_cloak} WHERE link LIKE '$url'" );
      }
      $url = trailingslashit(get_option( 'siteurl' ))."url".'/'.$uid;
      $link = $matches[1].$matches[2].$url.$matches[2].$matches[4].$matches[5].$matches[6];
      return $link;
    } else {
      return $matches[0];
    }
  }

  function wpt_cloak_affiliate_links_content_cloak($content){
    if(is_page()){
       return $content;
    } else {
      $wptlc_url_pattern = '/(<a[\s]+[^>]*href\s*=\s*)([\"\'])([^\2>]+?)\2([^<>]*>)((?sU).*)(<\/a>)/i';
      $content = preg_replace_callback($wptlc_url_pattern, 'wpt_cloak_affiliate_links_rewriter', $content);

      return $content;
    }
  }
  add_filter('the_content', 'wpt_cloak_affiliate_links_content_cloak', 11);

  function wpt_cloak_affiliate_links_rewrite_rules($wp_rules){
    global $wp_rewrite;
    $cloaker_rules = "
# WP Turbo Cloaker Starts
<IfModule mod_rewrite.c>
RewriteEngine On
RewriteRule ^url/([^/]*)/?$ ".WPT_CLOAKER_URL."?key=$1 [L]
</IfModule>
# WP Turbo Cloaker Ends
".$wp_rules;
    return $cloaker_rules;
  }
  add_filter('mod_rewrite_rules', 'wpt_cloak_affiliate_links_rewrite_rules');
}

function wpt_init() {
  global $wpt;
  foreach($wpt->available_modules as $available_module) {
    $module_wp_head_function = 'wpt_'.$available_module.'_init';
    if(function_exists($module_wp_head_function))
      $module_wp_head_function();
  }
}
add_action('init', 'wpt_init');

function wpt_head() {
  global $wpt;
  foreach($wpt->available_modules as $available_module) {
    $module_wp_head_function = 'wpt_'.$available_module.'_wp_head';
    if(function_exists($module_wp_head_function))
      $module_wp_head_function();
  }
}
add_action('wp', 'wpt_head');
?>
