<?php
/*
Plugin Name: ClickBump JumpStart
Plugin URI: http://clickbump.com/support
Description: Sets up your site's default seo and adsense settings and creates default page placeholders.
Version: 2.01
Author: Scott Blanchard
Author URI: http://clickbump.com/


== copyright ==

Copyright 2009-2010  Scott Blanchard (support: clickbump.com/support)
This program is licensed software; It is not to be shared, transfered or distributed
to anyone other than the person it was originally license to, without prior written permission.


== Description ==

Ideally, you should only edit the .html and .css files in the jumpstart folder.
Most users will not need to touch this file. If you accept the default values
you are using the same system I use for the clickbump method.

At best, you might decide to change the first group of settings you see below.

However, if you want to customize any or all theme options
you can do so below. If you have any problems with post content not showing up,
make sure all your files, including this one, are saved as UTF-8 formatted files.

--------------------------------------------------------------------*/
function cb_activate_jumpstart(){global $AdsenseDisabled,$ContactPage,$AboutPage,$homePublish,$blogPrivate,$PrivacyPage,$removeAbout,$removeHelloWorld,$friendlyURLS,$yearMonthFolders,$home_link_title;if ( get_option( 'cb2_jumpstarted' ) !== "1"){






/* IF YOU ARE NOT HAPPY WITH DEFAULT SETTINGS YOU CAN CHANGE THEM BELOW, THEN SAVE THIS FILE
--------------------------------------------------------------------*/

// Disable Adsense to start?
$AdsenseDisabled = false;

// Create a Contact Us Page?
$ContactPage = true;

// Create an About Us Page?
$AboutPage = true;

// Set home page to published?
$homePublish = true;

// Create a Privacy Policy Page?
$PrivacyPage = true;

// Remove the WordPress default "About" page
$removeAbout = true;

// Remove the WordPress default "Hello World" post
$removeHelloWorld = true;

// Set Permalinks to SEO Friendly Pagename
$friendlyURLS = true;

// Use Month & Year Folders.
$yearMonthFolders = false;

// Home Link Title. Leave blank for make home link the same as blog title
$home_link_title = "";

/*
Make Blog Private? 
Leave this false unless you do NOT want search engines to index your site.
If you set this true, you will need to uncheck this option in ClickBump Options 
before your site can be accessed by search engines
*/
$blogPrivate = false;






























/* ADVANCED USERS WITH UNIQUE REQUIREMENTS MAY WANT TO EDIT THESE SETTINGS
--------------------------------------------------------------------*/

//Template
	$cb2_theme = "clickbumped";

//Template Header Color	
	$cb2_theme_header_color = "#556b2f";

//Template Sidebar Color	
	$cb2_theme_sidebar_color = "#556b2f";
		
//Move top-menu Links to Sidebar?
	$cb2_top_menu_sidebar = true;

//Remove Site Menu from Sidebar?
	$cb2_hide_sitemenu = false;

//Remove Recent Posts from Sidebar? (first value is for legacy support. we changed this in 3.1 to cb2_hide_recent)
	 $cb2_posts_in_sidebar = true;
	 $cb2_hide_recent = false;

//Show Sitemap Link in Sidebar & Footer?
	 $cb2_sitemap = true;

//Sidebar Heading for Site Pages
	 $cb2_sidebar_heading_site = "Site Menu";

//Site Pages Default Count
	$cb2_sitemap_count = "-1";

//Sidebar Heading for Current Posts
	 $cb2_sidebar_heading_current = "Current Posts";
		 
//Current Posts Default Count
	$cb2_current_count = "-1";

//Sidebar Heading for Recent Posts
	 $cb2_sidebar_heading_recent = "Recent Posts";
		 
//Recent Posts Default
	$cb2_recent_count = "-1";

//Use Page Excerpts for Google Description
	 $cb2_post_description = true;

//Google Search Results Description (fallback if no excerpt)
	 $cb2_site_description = "";

//Google Webmaster Meta Tag (LEAVE AS IS, its loaded from google_webmaster_metatag.html in the jumpstart folder)
	$cb2_google_webmaster_meta = "";

//Allow indexing of Archive and Categories
	$cb2_noindex_archive = false;

//Adsense Client ID
	$cb2_adsense_client_id = "";

//336x280 Adsense Slot ID
	$cb2_adsense_ad_slot_id = "";
	 
//250x250 Adsense Slot ID (google_ad_slot)
	$cb2_adsense_ad_slot_id_sbs = "";

//Add Adsense Link Unit to Sidebar?
	 $cb2_adsense_link_unit = false;
	 
//Sidebar google_ad_slot ID for Link Unit
	$cb2_adsense_ad_slot_id2 = "";

//Disable Adsense?
	 $cb2_adsense_disable = $AdsenseDisabled;

//Custom Home Link Title
	$cb2_home_link_title = $home_link_title;

//Show Post Excerpt Text Under Post Title?
	$cb2_enable_excerpt = true;

//Show Post Comments?
	$cb2_comments_posts = false;

//Show Page Comments?
	$cb2_comments_pages = false;

//Show Post Tags?
	$cb2_show_tags = false;

//Product Image Underscores?
	$cb2_underscores = false;	

//Custom CSS Code (LEAVE AS IS, Its loaded from custom_css_code.css in the jumpstart folder)
	$cb2_custom_css = "";

//Custom Image Code  (LEAVE AS IS, Its loaded from custom_image_code.html in the jumpstart folder)
	 $cb2_custom_images = "";

//Custom Hidden Footer Code  (LEAVE AS IS, Its loaded from custom_footer_code.css in the jumpstart folder)
	 $cb2_custom_footer ="";

//Custom Visible Footer Code (LEAVE AS IS, Its loaded from custom_footer_visible_code.css in the jumpstart folder)
	 $cb2_custom_footer_visible = "";

 //Affiliate Link for Product Images
	$cb2_affiliate_link = "";

 //Make blog public
	$cb2_blogPrivate = $blogPrivate;

//Set Permalinks for SEO (about-us instead of ?p=367)
	$cb2_friendlyURLS = $friendlyURLS;
















/*
ALERT > DO NOT EDIT ANYTHING BELOW THIS LINE. ALL USER DEFINED SETTINGS ARE ABOVE
-------------------------------------------------------------------------------------------*/

if(file_exists(ABSPATH.'/wp-content/plugins/jumpstart/google_adsense_code.html'))
	{
		$code = file_get_contents(ABSPATH.'/wp-content/plugins/jumpstart/google_adsense_code.html');
		if (preg_match('/google_ad_client\s*=\s*"([^"]+)"\s*;/', $code, $m)) {
			$cb2_adsense_client_id = $m[1];
		}
		if (preg_match('/google_ad_slot\s*=\s*"([^"]+)"\s*;/', $code, $m)) {
			$cb2_adsense_ad_slot_id = $m[1];
		}
	}

		update_option('cb2_adsense_client_id', $cb2_adsense_client_id);
		update_option('cb2_adsense_ad_slot_id', $cb2_adsense_ad_slot_id);
		if(file_exists(ABSPATH.'wp-content/plugins/jumpstart/google_webmaster_metatag.html')){$cb2_google_webmaster_meta = file_get_contents(ABSPATH.'wp-content/plugins/jumpstart/google_webmaster_metatag.html');}else{$cb2_google_webmaster_meta = "";}
		update_option('cb2_google_webmaster_meta', $cb2_google_webmaster_meta);
		update_option('cb2_noindex_archive', $cb2_noindex_archive);
		update_option('cb2_theme', $cb2_theme);
		update_option('cb2_theme_header_color', $cb2_theme_header_color);
		update_option('cb2_theme_sidebar_color', $cb2_theme_sidebar_color);
		update_option('cb2_top_menu_sidebar', $cb2_top_menu_sidebar);
		update_option('cb2_posts_in_sidebar', $cb2_posts_in_sidebar);
		update_option('cb2_hide_recent', $cb2_hide_recent);
		update_option('cb2_sitemap', $cb2_sitemap);
		update_option('cb2_sidebar_heading_site', $cb2_sidebar_heading_site);
		update_option('cb2_sitemap_count', $cb2_sitemap_count);
		update_option('cb2_sidebar_heading_current', $cb2_sidebar_heading_current);
		update_option('cb2_current_count', $cb2_current_count);
		update_option('cb2_sidebar_heading_recent', $cb2_sidebar_heading_recent);
		update_option('cb2_recent_count', $cb2_recent_count);
		update_option('cb2_post_description', $cb2_post_description);
		update_option('cb2_site_description', $cb2_site_description);
		update_option('cb2_adsense_ad_slot_id_sbs', $cb2_adsense_ad_slot_id_sbs);
		update_option('cb2_adsense_link_unit', $cb2_adsense_link_unit);
		update_option('cb2_adsense_ad_slot_id2', $cb2_adsense_ad_slot_id2);
		update_option('cb2_adsense_disable', $cb2_adsense_disable);
		update_option('cb2_home_link_title', $home_link_title);
		update_option('cb2_enable_excerpt', $cb2_enable_excerpt);
		update_option('cb2_comments_posts', $cb2_comments_posts);
		update_option('cb2_comments_pages', $cb2_comments_pages);
		update_option('cb2_show_tags', $cb2_show_tags);
		update_option('cb2_underscores', $cb2_underscores);
		if(file_exists(ABSPATH.'wp-content/plugins/jumpstart/custom_css_code.css')){$cb2_custom_css = file_get_contents(ABSPATH.'wp-content/plugins/jumpstart/custom_css_code.css');}else{$cb2_custom_css = "";}
		update_option('cb2_custom_css', $cb2_custom_css);
		if(file_exists(ABSPATH.'wp-content/plugins/jumpstart/custom_image_code.html')){$cb2_custom_images = file_get_contents(ABSPATH.'wp-content/plugins/jumpstart/custom_image_code.html');}else{$cb2_custom_images = "";}
		update_option('cb2_custom_images', $cb2_custom_images);
		if(file_exists(ABSPATH.'wp-content/plugins/jumpstart/custom_footer_code.html')){$cb2_custom_footer = file_get_contents(ABSPATH.'wp-content/plugins/jumpstart/custom_footer_code.html');}else{$cb2_custom_footer = "";}
		update_option('cb2_custom_footer', $cb2_custom_footer);
		if(file_exists(ABSPATH.'wp-content/plugins/jumpstart/custom_footer_visible_code.html')){$cb2_custom_footer_visible = file_get_contents(ABSPATH.'wp-content/plugins/jumpstart/custom_footer_visible_code.html');}else{$cb2_custom_footer_visible = "";}
		update_option('cb2_custom_footer_visible', $cb2_custom_footer_visible);
		update_option('cb2_affiliate_link', $cb2_affiliate_link);
		update_option('cb2_blogPrivate', $blogPrivate);
		update_option('cb2_friendlyURLS', $friendlyURLS);


/* Remove WordPress Default About page
--------------------------------------------------------------------*/
if($removeAbout)
		{
		wp_delete_post(2);
		}

/* Remove WordPress Default Hello World page
--------------------------------------------------------------------*/
if($removeHelloWorld)
		{
		wp_delete_post(1);
		}

/* Set Blog Privacy Defaults
--------------------------------------------------------------------*/
if(!$blogPrivate)
	{
	update_option('blog_public', 1);
	}
else
	{
	update_option('blog_public', 0);
	}

/* USE YEAR MONTH FOLDERS
--------------------------------------------------------------------*/
if(!$yearMonthFolders)
	{
	update_option('uploads_use_yearmonth_folders', 0);
	}


/* utility functions DO NOT EDIT
--------------------------------------------------------------------*/
function doReplace($content)
{
	$tags = array('[site-name]', '[site-url]', '[site-email]');
	$words = array(get_bloginfo('name'), get_bloginfo('url'), get_bloginfo('admin_email'));
	$content = str_replace($tags, $words, $content);
	return $content;
}

function doSpin($content) {
  return preg_replace_callback('!\[%(.*?)%\]!', 'pick_one', $content);
}

function pick_one($matches) {
  $choices = explode('|', $matches[1]);
  return $choices[array_rand($choices)];
}

/* MAIN POST
--------------------------------------------------------------------*/
		$my_post = array();
		$my_post['post_title'] = get_bloginfo('name');
		if(file_exists(ABSPATH.'/wp-content/plugins/jumpstart/main_post_content.html')){$my_main_page = file_get_contents(ABSPATH.'/wp-content/plugins/jumpstart/main_post_content.html');}else{$my_main_page = "";}
		$my_post_spin = doSpin($my_main_page);
		$my_post_replace = doReplace($my_post_spin);
		$my_post['post_content'] = addslashes($my_post_replace);
		$my_post['post_type'] = 'post';
		if($homePublish){$my_post['post_status'] = 'publish';}
		$post_id = wp_insert_post($my_post);
		stick_post($post_id);



/* ABOUT US
--------------------------------------------------------------------*/
if($AboutPage)
		{
		$my_post1 = array();
		$my_post1['post_title'] = 'About Us';
		if(file_exists(ABSPATH.'/wp-content/plugins/jumpstart/about_us.html')){$my_about_page = file_get_contents(ABSPATH.'/wp-content/plugins/jumpstart/about_us.html');}else{$my_about_page = "";}
		$my_post1_spin = doSpin($my_about_page);
		$my_post1_replace = doReplace($my_post1_spin);
		$my_post1['post_content'] = addslashes($my_post1_replace);
		$my_post1['post_type'] = 'page';
		$my_post1['post_status'] = 'publish';
		wp_insert_post($my_post1);
		}



/* CONTACT US
--------------------------------------------------------------------*/
if($ContactPage)
		{
		$my_post2 = array();
		$my_post2['post_title'] = 'Contact Us';
		if(file_exists(ABSPATH.'/wp-content/plugins/jumpstart/contact_us.html')){$my_contact_page = file_get_contents(ABSPATH.'/wp-content/plugins/jumpstart/contact_us.html');}else{$my_contact_page = "";}
		$my_post2_spin = doSpin($my_contact_page);
		$my_post2_replace = doReplace($my_post2_spin);
		$my_post2['post_content'] = addslashes($my_post2_replace);
		$my_post2['post_type'] = 'page';
		$my_post2['post_status'] = 'publish';
		wp_insert_post($my_post2);
		}



/* PRIVACY POLICY
--------------------------------------------------------------------*/
if($PrivacyPage)
		{
		$my_post3 = array();
		$my_post3['post_title'] = 'Privacy Policy';
		if(file_exists(ABSPATH.'/wp-content/plugins/jumpstart/privacy_policy.html')){$my_privacy_policy = file_get_contents(ABSPATH.'/wp-content/plugins/jumpstart/privacy_policy.html');}else{$my_privacy_policy = "";}
		$my_post3_spin = doSpin($my_privacy_policy);
		$my_post3_replace = doReplace($my_post3_spin);
		$my_post3['post_content'] = addslashes($my_post3_replace);
		$my_post3['post_type'] = 'page';
		$my_post3['post_status'] = 'publish';
		wp_insert_post($my_post3);
		}
		

/* CLEANUP
--------------------------------------------------------------------*/
	if($friendlyURLS)
		{
		wp_cache_flush();
		global $wp_rewrite;
		$wp_rewrite->set_permalink_structure('/%postname%/');
		$wp_rewrite->flush_rules();
		}
		update_option('cb2_jumpstarted', "1");		
		}

	}

register_activation_hook(__FILE__, 'cb_activate_jumpstart');
?>