<?php             
/**
Plugin Name: SEO Spotlight Ultimate
Plugin URI: http://www.seo-spotlight.com/
Description: SEO Spotlight Ultimate plugin optimize your blog posts and pages for the Search Engines effectively!.It also supports SocialMetrics reports, Duplicate-Content-Checker and Video-Sitemap-Generator.
SEO Features
  Auto-check current post
  Auto-check timing (seconds)
  Title/separator (default)
  Seo Title - position (Admin post listing)
  Show's SEO score
  Advanced SEO rules and settings.
  Keyword in title tag
  Keyword in alt text
  Keyword Density
  Link Density
  Keywords in H1, H2, H3
  Keywords in font style - In strong, bold, italic, strong.
  Show SEO Scores in Gauge Dial or Progress Bar.
Show Social Reports for Facebook, Twitter and Google+.
Generate Vertbar Chart for Posts and Pages SEO Scores and Likes.
Duplicate Content Checker(Check Duplicate Content within Posts).
Generate XML sitemap for videos of youtube,vimeo.
Version: 1.0.0
Author: Bill
Author URI: http://www.seo-spotlight.com/
License: GPL
*/
class slSeo {
  // Declare variables public
  public $prefix = 'slSeo';
  public $admin_features;
  public $admin_options;
  public $video_options;
  public $admin_reports_options;
  // Constuctor called when object initialized.
  function __construct() {
	  $this->constants();
	  //Global functions
	  $this->functions();
	  $this->admin();
	  /* Plugin init hook. */
	  do_action("{$this->prefix}_init");
  }
  // Defines the constant paths for use.
  function constants() {
	  global $wpdb;
	  $sldup_path     = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', __FILE__);
	  $sldup_path     = str_replace('\\','/',$sldup_path);
	  $sldup_dir      = substr($sldup_path,0,strrpos($sldup_path,'/'));
	  $sldup_siteurl  = get_bloginfo('wpurl');
	  $sldup_siteurl  = (strpos($sldup_siteurl,'http://') === false) ? get_bloginfo('siteurl') : $sldup_siteurl;
	  $sldup_fullpath = $sldup_siteurl.'/wp-content/plugins/'.$sldup_dir.'/';
	  $sldup_relpath  = str_replace('\\','/',dirname(__FILE__));
	  define('SLDUP_PATH', $sldup_path);	
	  define('SLDUP_SITEURL', $sldup_siteurl);
	  define('SLDUP_FULLPATH', $sldup_fullpath);
	  define('SLSEO_PLUGIN_DIR', plugin_dir_path(__FILE__));
	  define('SLSEO_PLUGIN_URI', plugin_dir_url(__FILE__));
	  define('SLSEO_PLUGIN_LIBRARY', SLSEO_PLUGIN_DIR);
	  define('SLSEO_SL_ADMIN', SLSEO_PLUGIN_DIR . 'sl_admin');
	  define('SLSEO_PLUGIN_ADMIN', SLSEO_SL_ADMIN . '/admin');
	  define('SLSEO_PLUGIN_FUNCTIONS', SLSEO_SL_ADMIN . '/functions');
	  define('SLSEO_ADMIN_IMAGES', SLSEO_PLUGIN_URI . 'sl_admin/images');
	  define('SLSEO_ADMIN_CSS', SLSEO_PLUGIN_URI . 'sl_admin/css');
	  define('SLSEO_ADMIN_JS', SLSEO_PLUGIN_URI . 'sl_admin/js');
	  define('SLSEO_PLUGIN_IMAGES', SLSEO_PLUGIN_URI . 'images');
	  define('SLSEO_PLUGIN_CSS', SLSEO_PLUGIN_URI . 'css');
	  define('SLSEO_PLUGIN_JS', SLSEO_PLUGIN_URI . 'js');
	  define( 'SLSEO_PLUGIN_BASENAME', plugin_basename( __FILE__ ) );
  }
  // Load admin files.
  function admin() {
	  if (is_admin()) {
		  require_once( SLSEO_PLUGIN_ADMIN . '/admin_options_page.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/onpage_seo_features.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/options_page_content.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/save_post_block.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/sl_social_reports_settings.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/sl_social_reports.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/check-duplicate-post.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/sl_fields_description.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/sl-video-sitemap-generator.php' );
		  require_once( SLSEO_PLUGIN_ADMIN . '/sl_url_searching.php' );
	  }
	  require_once( SLSEO_PLUGIN_DIR . '/sl-chart-builder.php' );
	  require_once( SLSEO_PLUGIN_DIR . '/sl_diagram_view.php' );
  }  
   // Loads the core functions.
  function functions() {
	  // functions
		  require_once( SLSEO_PLUGIN_FUNCTIONS . '/sl_core.php' );
		  require_once( SLSEO_PLUGIN_FUNCTIONS . '/sl_options_generator.php' );
		  require_once( SLSEO_PLUGIN_FUNCTIONS . '/sl_save_options.php' );
  } 
}
/* Initialize seo spotlight plugin. */

$slSeo = new slSeo();

// Adding columns in manage post 

if (is_admin ()) {
  if(get_option($slSeo->prefix . '_' . 'showScoreSeo') == 'true'){
	  add_filter('manage_posts_columns', 'slSeo_add_post_columns');
	  function slSeo_add_post_columns($new_post_columns) {
		  $new_post_columns['cb'] = '<input type="checkbox" />';
		  $new_post_columns['seoScore'] = __('SEO Score');
		  $new_post_columns['facebook'] = __('Facebook');
		  $new_post_columns['twitter'] = __('Twitter');
		  $new_post_columns['google1'] = __('Google+');
		  $new_post_columns['title'] = __('Title');
		  $new_post_columns['author'] = __('Author');
		  $new_post_columns['categories'] = __('Category');
		  $new_post_columns['tags'] = __('Tags');
		  $new_post_columns['comments'] = __('Comments');
		  $new_post_columns['date'] = _x('Date', 'column name');
		  return $new_post_columns;
	  }
	  // hook to admin_init function

	  add_action('manage_posts_custom_column', 'slSeo_manage_my_columns');
	   function slSeo_manage_my_columns($column){
		  global $post;
		  switch($column):
			  case 'seoScore':
				  $curr_hits = get_post_meta($post->ID,  'slSeo_lastScore', true);
				  if(trim($curr_hits == "")) $curr_hits = 0;
				  echo "<div class='slSeoPoints'>" . $curr_hits . "%</div>";
				  break;
			  case 'facebook':
				 ?><iframe src="http://www.facebook.com/plugins/like.php?href=<?php the_permalink(); ?>&send=false&layout=button_count&width=100&show_faces=false&action=like&colorscheme=light&font=tahoma" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:100px; height:21px;" allowTransparency="true"></iframe><?php 
				  break;	
			  case 'twitter': ?>
				  <a href="http://twitter.com/share" class="twitter-share-button" data-text="<?php the_title(); ?>" data-count="horizontal" data-size="medium" data-related="<?php echo $post_type; ?>" data-url="<?php the_permalink() ?>" >Tweet</a>
			  <?php 
				  break;
			  case 'google1':?>
				  <g:plusone size="medium"  href="<?php the_permalink(); ?>"></g:plusone> <?php
				  break;
		  endswitch;
	  }
	  // hook to add custom column in pages
	  add_filter('manage_pages_columns', 'slSeo_add_page_columns');
	  // function to add custom column in pages
	  function slSeo_add_page_columns($new_page_columns) {
		  $new_page_columns['cb'] = '<input type="checkbox" />';
		  $new_page_columns['seoScore'] = __('SEO Score');
		  $new_page_columns['facebook'] = __('Facebook');
		  $new_page_columns['twitter'] = __('Twitter');
		  $new_page_columns['google1'] = __('Google+');
		  $new_page_columns['title'] = __('Title');
		  $new_page_columns['author'] = __('Author');
		  $new_page_columns['comments'] = __('Comments');
		  $new_page_columns['date'] = _x('Date', 'column name');
		  return $new_page_columns;
	  }
	   // hook to add custom column functionality

	  add_action('manage_pages_custom_column', 'slSeo_manage_pages_my_columns',10,2);

	   // function to add custom column functionality

	   function slSeo_manage_pages_my_columns($column, $post_id){
		  global $post;
		   if( $column == 'seoScore' ) {
			   $curr_hits = get_post_meta($post->ID,  'slSeo_lastScore', true);
			   if(trim($curr_hits == "")) $curr_hits = 0;
			   echo "<div class='slSeoPoints'>" . $curr_hits . "%</div>";
		  } 
		  else if( $column == 'facebook' ) {
		  ?><iframe src="http://www.facebook.com/plugins/like.php?href=<?php the_permalink(); ?>&send=false&layout=button_count&width=100&show_faces=false&action=like&colorscheme=light&font=tahoma" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:100px; height:21px;" allowTransparency="true"></iframe><?php 
		  }
		  else if( $column == 'twitter' ) {
		  ?><a href="http://twitter.com/share" class="twitter-share-button" data-text="<?php the_title(); ?>" data-count="horizontal" data-size="medium" data-related="<?php echo $post_type; ?>" data-url="<?php the_permalink() ?>" >Tweet</a><?php 
		  }
		  else if( $column == 'google1' ) {
		  ?> <g:plusone size="medium"></g:plusone><?php 
		  }
	  } 

	  function slSeo_custom_cols_css() {
		  echo '<style type="text/css">
		  th#seoScore {
			  width: 80px;
		  }
		  .slSeoPoints {
			 width: 80%;
			 height: 21px;
			 text-align: center;
			 padding: 0;
			 font-size: 12px;
			 text-shadow: 1px 1px 1px #fff;
			 font-weight: bold;
		  }
		  </style>';
	  }
	  add_action('admin_head', 'slSeo_custom_cols_css');
  }

}
/* Initializes plugin settings */

function slSeo_settings_page_init() {
   global $slSeo;
   $checkdup = new CheckDuplicatePost();
   $sldiagram = new sl_diagram_view();

  /* Create the plugin settings page. */
  add_menu_page('SEO Spotlight Ultimate', 'SEO Spotlight Ultimate', 'publish_posts',__FILE__, 'slSeo_create_settings_page');
  //add_submenu_page('slSeo','','','publish_posts','slSeo','slSeo_create_settings_page');
  
  // Creating submenu for SEO Spotlight
  add_submenu_page( __FILE__, 'Main Control Settings', 'Main Control Settings', 'manage_options', __FILE__, 'slSeo_create_settings_page' );

  // Creating submenu for SEO Spotlight fields description

  add_submenu_page( __FILE__, 'SEO Spotlight Ultimate Fields Description', 'SEO Spotlight Ultimate Fields Description', 'manage_options', 'seo_spotlight_fields_description', 'sl_fields_description' ); 
  
  // Creating submenu for SEO Spotlight fields description

  //add_submenu_page( __FILE__, 'SEO URL Searching', 'SEO URL Searching', 'manage_options', 'seo_url_searching_description', 'url_searching_option' ); 

  // Creating submenu for showing on page seo features options

  add_submenu_page(__FILE__, 'On Page SEO Settings', 'On Page Seo Settings', 'administrator', 'seosl_features', 'slSeo_onpage_features_page');

  // Creating submenu for social reports settings

  add_submenu_page( __FILE__, 'Social Reports Settings', 'Social Reports Settings', 'manage_options', 'socialreports_settings', 'sl_socialReports_settings' ); 

  // Creating submenu for showing social reports

  add_submenu_page( __FILE__, 'Social Reports', 'Social Reports', 'manage_options', 'social_reports', 'sl_display_socialReports' ); 
  
  //Creating menu for showing SEO searching
  
  add_submenu_page( __FILE__, 'SEO URL Searching', 'SEO URL Searching', 'manage_options', 'url_searching', 'url_searching_option' );

	  // Creating submenu for duplicate content check

  add_submenu_page( __FILE__, 'Check Duplicate Post', 'Check Duplicate Content', 'manage_options', 'check_duplicate_content', array(&$checkdup, 'sldupManagePg') ); 

  add_submenu_page( __FILE__, 'Pages and Posts in Diagram View', 'Pages and Posts in Diagram View', 'manage_options', 'page_post_diagram', array( &$sldiagram, 'sitemap_setting') ); 

  // Creating submenu for SEO Spotlight fields description

  add_submenu_page( __FILE__, 'Video Sitemap Generator', 'Video Sitemap Generator', 'manage_options', 'Video-Sitemap-Generator', 'sl_video_sitemap_generator' ); 
}

/* Adding css and js in admin */

function slseo_add_admin_css_js() {
  global $pagenow;
  wp_enqueue_style( 'seo-spotlight-css', plugins_url( '/sl_admin/css/style.css' , __FILE__ ) );
  if(get_option('slSeo_seoscorebar') == 'true')
  wp_enqueue_style( 'seo-spotlight-progress-css', plugins_url( '/sl_admin/css/progress-bar.css' , __FILE__ ) );
  wp_enqueue_style( 'diagram-css', plugins_url( '/css/sl_diagram_view_arrows.css' , __FILE__ ) );
  global $pagenow;
  if( $pagenow == 'admin.php' ) {
	  wp_enqueue_script( 'seo-spotlight-coreui', plugins_url( '/sl_admin/js/ui.core.js' , __FILE__ ) );
	  wp_enqueue_script( 'seo-spotlight-cookie', plugins_url( '/sl_admin/js/jquery.cookie.js' , __FILE__ ) );	
	  wp_enqueue_script( 'seo-spotlight-tabs', plugins_url( '/sl_admin/js/ui.tabs.js' , __FILE__ ) );	
	  wp_enqueue_script( 'seo-spotlight-js', plugins_url( '/sl_admin/js/js.js' , __FILE__ ) );
  }
  wp_enqueue_script( 'seo-spotlight-gauge', 'https://www.google.com/jsapi' );	
  if(get_option('slSeo_seoscorebar') == 'true')
  wp_enqueue_script( 'seo-spotlight-slSeo', plugins_url( '/sl_admin/js/sl.seo.js' , __FILE__ ) );	
  else
  wp_enqueue_script( 'seo-spotlight-slSeo-gauge', plugins_url( '/sl_admin/js/sl.gauge.js' , __FILE__ ) );	
	  //wp_enqueue_script( 'seo-spotlight-slSeo-meta', plugins_url( '/sl_admin/js/sl-sitemap-seo.js' , __FILE__ ) );	
}

//hook for admin css and js
add_action( 'admin_enqueue_scripts', 'slseo_add_admin_css_js' );

/* Initialize the plugin admin functionality. */
add_action('init', 'slSeo_admin_init' );

function slSeo_admin_init() {
  global $slSeo;
  $prefix = $slSeo->prefix;
  /* Initialize the plugin settings page. */
  add_action('admin_menu', 'slSeo_settings_page_init');
  add_action('admin_head', 'slSeo_admin_head');
  add_action('admin_head', 'admin_option_fields');
  add_action('admin_head', 'slSeo_save_admin_options');
  add_action('admin_head', 'sl_video_sitemap_option_fields');
}
/***  Add seo score js to admin header  ***/
function slSeo_admin_head() {
  global $slSeo, $post;
  $prefix = $slSeo->prefix;  
  	global $current_screen; 
  	if(($current_screen->post_type =='post' && $current_screen->action == 'add') || ( $current_screen->post_type =='page' && $current_screen->action == 'add'))
	{ 
		$screen_action = "add_action";
	}
	if($screen_action == "add_action")
	{
	?>	
		<script type="text/javascript">
		jQuery(document).ready(function() {
			slSeo.init({
			   uri: '<?php echo SLSEO_PLUGIN_URI;?>',
			   seoSettings: {
				   autoCheck                    : '<?php echo get_option($prefix . '_' . 'autoCheck');?>',
				   autoCheckTimes               : '<?php echo get_option($prefix . '_' . 'autoCheckTimes');?>',
				   rulesCheck : {
					   keyword_title_tag            : '<?php echo get_option($prefix . '_' . 'keyword_title_tag');?>',
					   keyword_meta_description     : '<?php echo get_option($prefix . '_' . 'keyword_meta_description');?>',
					   keyword_meta_keywords        : '<?php echo get_option($prefix . '_' . 'keyword_meta_keywords');?>',
					   keyword_meta_density         : '<?php echo get_option($prefix . '_' . 'keyword_meta_density');?>',
					   keyword_density              : '<?php echo get_option($prefix . '_' . 'keyword_density');?>',
						link_meta_density         : '<?php echo get_option($prefix . '_' . 'link_meta_density');?>',
					   link_density              : '<?php echo get_option($prefix . '_' . 'link_density');?>',
					   keyword_meta_H1              : '<?php echo get_option($prefix . '_' . 'keyword_meta_H1');?>',
					   keyword_meta_H2              : '<?php echo get_option($prefix . '_' . 'keyword_meta_H2');?>',
					   keyword_meta_H3              : '<?php echo get_option($prefix . '_' . 'keyword_meta_H3');?>',
					   keyword_meta_fontsize        : '<?php echo get_option($prefix . '_' . 'keyword_meta_fontsize');?>',
					   keyword_meta_img_alt         : '<?php echo get_option($prefix . '_' . 'keyword_meta_img_alt');?>'
				   }
			   }
			});
		});
    </script>
	<?php 
	}
    else
    {
		$slSeo_keyword_title_tag = get_post_meta($post->ID, 'slSeo_keyword_title_tag', true);
		$slSeo_keyword_meta_description = get_post_meta($post->ID, 'slSeo_keyword_meta_description', true);
		$slSeo_keyword_meta_keywords = get_post_meta($post->ID, 'slSeo_keyword_meta_keywords', true);
		$slSeo_keyword_meta_density = get_post_meta($post->ID, 'slSeo_keyword_meta_density', true);
		$slSeo_keyword_density = get_post_meta($post->ID, 'slSeo_keyword_density', true);
		$slSeo_link_density = get_post_meta($post->ID, 'slSeo_link_density', true);
		$slSeo_link_meta_density = get_post_meta($post->ID, 'slSeo_link_meta_density', true);
		$slSeo_keyword_meta_H1 = get_post_meta($post->ID, 'slSeo_keyword_meta_H1', true);
		$slSeo_keyword_meta_H2 = get_post_meta($post->ID, 'slSeo_keyword_meta_H2', true);
		$slSeo_keyword_meta_H3 = get_post_meta($post->ID, 'slSeo_keyword_meta_H3', true);
		$slSeo_keyword_meta_fontsize = get_post_meta($post->ID, 'slSeo_keyword_meta_fontsize', true);
		$slSeo_keyword_meta_img_alt = get_post_meta($post->ID, 'slSeo_keyword_meta_img_alt', true);
		if($slSeo_keyword_title_tag == 'false' && $slSeo_keyword_meta_description == 'false' && $slSeo_keyword_meta_keywords == 'false' && $slSeo_keyword_meta_density == 'false' && $slSeo_keyword_density == '' && $slSeo_link_density == '' && $slSeo_link_meta_density == 'false' && $slSeo_keyword_meta_H1 == 'false' && $slSeo_keyword_meta_H2 == 'false' && $slSeo_keyword_meta_H3 == 'false' && $slSeo_keyword_meta_fontsize == 'false' && $slSeo_keyword_meta_img_alt == 'false')
		{
		?>	
			<script type="text/javascript">
		jQuery(document).ready(function() {
			slSeo.init({
			   uri: '<?php echo SLSEO_PLUGIN_URI;?>',
			   seoSettings: {
				   autoCheck                    : '<?php echo get_option($prefix . '_' . 'autoCheck');?>',
				   autoCheckTimes               : '<?php echo get_option($prefix . '_' . 'autoCheckTimes');?>',
				   rulesCheck : {
					   keyword_title_tag            : '<?php echo get_option($prefix . '_' . 'keyword_title_tag');?>',
					   keyword_meta_description     : '<?php echo get_option($prefix . '_' . 'keyword_meta_description');?>',
					   keyword_meta_keywords        : '<?php echo get_option($prefix . '_' . 'keyword_meta_keywords');?>',
					   keyword_meta_density         : '<?php echo get_option($prefix . '_' . 'keyword_meta_density');?>',
					   keyword_density              : '<?php echo get_option($prefix . '_' . 'keyword_density');?>',
						link_meta_density         : '<?php echo get_option($prefix . '_' . 'link_meta_density');?>',
					   link_density              : '<?php echo get_option($prefix . '_' . 'link_density');?>',
					   keyword_meta_H1              : '<?php echo get_option($prefix . '_' . 'keyword_meta_H1');?>',
					   keyword_meta_H2              : '<?php echo get_option($prefix . '_' . 'keyword_meta_H2');?>',
					   keyword_meta_H3              : '<?php echo get_option($prefix . '_' . 'keyword_meta_H3');?>',
					   keyword_meta_fontsize        : '<?php echo get_option($prefix . '_' . 'keyword_meta_fontsize');?>',
					   keyword_meta_img_alt         : '<?php echo get_option($prefix . '_' . 'keyword_meta_img_alt');?>'
				   }
			   }
			});
		});
    </script>	
    	<?php
    	}
        else
		{
		?>
        	<script type="text/javascript">
		jQuery(document).ready(function() {
			  slSeo.init({
				 uri: '<?php echo SLSEO_PLUGIN_URI;?>',
				 seoSettings: {
					 autoCheck                    : '<?php echo get_option($prefix . '_' . 'autoCheck');?>',
					 autoCheckTimes               : '<?php echo get_option($prefix . '_' . 'autoCheckTimes');?>',
					 rulesCheck : {
						 keyword_title_tag            : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_title_tag', true);?>',
						 keyword_meta_description     : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_description', true);?>',
						 keyword_meta_keywords        : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_keywords', true);?>',
						 keyword_meta_density         : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_density', true);?>',
						 keyword_density              : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_density', true);?>',
						 link_meta_density         : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'link_meta_density', true);?>',
						 link_density              : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'link_density', true);?>',
						 keyword_meta_H1              : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_H1', true);?>',
						 keyword_meta_H2              : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_H2', true);?>',
						 keyword_meta_H3              : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_H3', true);?>',
						 keyword_meta_fontsize        : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_fontsize', true);?>',
						 keyword_meta_img_alt         : '<?php echo get_post_meta($post->ID, $prefix . '_' . 'keyword_meta_img_alt', true);?>'
					 }
				 }
			  });
		  });
	</script>
        <?php
		}  
    }
}//END slSeo_admin_head() 
/* Use the admin_menu action to define the custom boxes */
add_action('admin_menu', 'slSeo_custom_box');
/* Adds a custom section to the "side" of the post edit screen */
function slSeo_custom_box() {
  add_meta_box('slSeo_post_markers', 'SEO Spotlight Post Values', 'slSeo_post_content_box_custom_box', 'post', 'normal', 'high');
  add_meta_box('slSeo_post_markers', 'SEO Spotlight Page Values', 'slSeo_post_content_box_custom_box', 'page', 'normal', 'high');
  /* live scores */
  add_meta_box('slSeo_livescore_markers', 'SEO Spotlight post score: <strong class="value"></strong>', 'slSeo_livescore_custom_box', 'post', 'side', 'high');
  add_meta_box('slSeo_livescore_markers', 'SEO Spotlight  page score: <strong class="value"></strong>', 'slSeo_livescore_custom_box', 'page', 'side', 'high');
}

/* Displays the custom field in the new custom post section */
function slSeo_post_content_box_custom_box() {
  global $post, $slSeo;
  $prefix = $slSeo->prefix;
  // use wp_nonce for verification
  echo '<input type="hidden" name="slSeo_post_markers_noncename" id="slSeo_post_markers_noncename" value="' . wp_create_nonce('nyc-slSeo') . '" />';
  foreach (post_option_fields () as $key => $value) {
	  if ($value['type'] == 'text') {
		  $value ['std'] = get_post_meta($post->ID, $value['id'], true);
		  echo '<div style="width: 100%;float: left;margin: 15px 0px 0px 10px; ">';
		  echo '<div style="float: left;width: 150px;font-weight: bold;">'.($value['name']).'</div>';
		  echo '<div style="float: left;width: 450px;font-weight: bold;">'.(slSeo_text($value)).'</div>';
		  echo '<div style="float: left"><i>'.($value['desc']).'</i></div>';
		  echo '</div>';
	  }
	  if ($value['type'] == 'textarea') {
		  $value ['std'] = get_post_meta($post->ID, $value['id'], true);
		  echo '<div style="width: 100%;float: left;margin: 15px 0px 0px 10px; ">';
		  echo '<div style="float: left;width: 150px;font-weight: bold;">'.($value['name']).'</div>';
		  echo '<div style="float: left;width: 450px;font-weight: bold;">'.(slSeo_textarea($value)).'</div>';
		  echo '<div style="float: left"><i>'.($value['desc']).'</i></div>';
		  echo '</div>';
	  }
  }
  echo '<div style="clear:both"></div>';
}
//Add meta tag for site verification entered by user into tag. 
function sl_wp_head() {
	  // Only need to put this on the home page
		  $sl_meta_tag = get_option('slSeo_GWT');
		  echo htmlspecialchars_decode($sl_meta_tag);
  }
add_filter('wp_head','sl_wp_head',0);
//Add a link to the settings page to the plugins list
function sl_plugin_action_links( $links, $file ) {
  if ( $file != SLSEO_PLUGIN_BASENAME )
	  return $links;
  $url = admin_url( 'admin.php?page=' . SLSEO_PLUGIN_BASENAME );
  $settings_link = '<a href="' . esc_attr( $url ) . '">' . esc_html( __( 'Settings') ) . '</a>';
  array_unshift( $links, $settings_link );
  return $links;
}
add_filter( 'plugin_action_links', 'sl_plugin_action_links', 10, 2 );