<?php
class sl_Charts
{
    private $chartNum = 0;
    private $installScripts = false;
    
    var $slnumColorGroups = 3;
    
	// Database Settings
    var $SL_TYPE = "vertbar";
	var $SL_WIDTH = 400;
	var $SL_HEIGHT = 200;
	var $SL_TITLE = "";
	var $SL_MARKERCOLOR = "FFFF00";
	var $SL_CHARTCOLOR = "FFFFFF";
	var $SL_CHARTFADECOLOR = "DDDDDD";
	var $SL_TABLECSS = "hentry";
	var $SL_IMGSTYLE = "text-align:center;float:center;";
	var $SL_WATERMARKCOLOR = "A0BAE9";
	var $SL_CURRENCY = "";
	var $SL_PRECISION = "";
	var $SL_HIDECHART = false;
	var $SL_IMAGEALT = "Likes";
	var $SL_IMAGETITLE = "";
	var $SL_COLORS_1 = "0070C0";
	var $SL_COLORS_2 = "D83E0F";
	var $SL_COLORS_3 = "945D1E";
	var $SL_GRID = false;
	var $SL_DATATABLE_TITLE = "Show/Hide Chart Data";
	var $SL_TABLEALWAYSOPEN = false;
	var $SL_AXISOPTS = "both";
	
	var $op; 
	    
	public function __construct()
    {   
        $sl_jsDir = plugins_url ( plugin_basename ( dirname ( __FILE__ ) ) ) . '/js/';
        wp_register_script('sl_Charts', "{$sl_jsDir}sl-chart-builder.js", false); 
        
        $this->init_options_map();
        $this->load_options();
    }
    
    function CTXID() 
    { 
        return get_class($this); 
    }   
	   
	public function output_scripts ()
    {
        if ($this->installScripts)
        {
            wp_enqueue_script('sl_Charts'); 
        }   
    }
 

	function init_options_map() 
	{
		$sl_opnames = array(
			'SL_TYPE', 'SL_WIDTH', 'SL_HEIGHT', 'SL_TITLE', 'SL_MARKERCOLOR', 'SL_CHARTCOLOR', 'SL_CHARTFADECOLOR', 'SL_TABLECSS', 'SL_IMGSTYLE', 'SL_WATERMARKCOLOR', 'SL_CURRENCY', 'SL_PRECISION','SL_HIDECHART', 'SL_IMAGEALT', 'SL_IMAGETITLE', 'SL_COLORS_1', 
'SL_COLORS_2', 'SL_COLORS_3', 'SL_GRID', 'SL_DATATABLE_TITLE', 'SL_TABLEALWAYSOPEN', 'SL_AXISOPTS',
		);
		$this->op = (object) array();
		foreach ($sl_opnames as $name)
			$this->op->$name = &$this->$name;
	}
	
	function load_options() 
	{
		$context = $this->CTXID();
		$options = $this->op;
		$saved = get_option($context);
		if ($saved) foreach ( (array) $options as $key => $val ) 
		{
			if (!isset($saved->$key)) continue;
			$this->assign_to($options->$key, $saved->$key);
		}

	}
	
	
	private function assign_to(&$var, $value) 
	{
		settype($value, gettype($var));
		$var = $value;
	}
	
 
    private function translate_numerics(&$value, $key) 
    {     
        if ($value == 'false') 
        {
        	$value = false;
        } elseif ($value == 'true') 
        {
            $value = true;
        }       
    }        
            
	public function sl_process_shortcode($atts, $content=null, $code="") 
	{  
	   	$haveIssue = FALSE;
	    $nearKey = "";
	    $nearValue = "";
	    $header = "";

	    if ($this->installScripts == false)
	    {
	       $plgDir = plugins_url ( plugin_basename ( dirname ( __FILE__ ) ) ); 
	       $this->installScripts = true;
	       $header = "<script type='text/javascript' src='" . $plgDir . "/js/sl-chart-builder.js'></script>\n";
	    }
	    
	    if ($atts)
	    {
    	    foreach ($atts as $key => $att)
    	    {
    	       $keyval = (int)$key;
    	       if ($keyval != 0 || strpos($key, "0") === 0)
    	       {
                    $haveIssue = TRUE;
                    $nearKey = $keyval;
                    $nearValue = $att;
                    break;
    	       }
    	    }
	    }
	    	
	    if ($haveIssue === TRUE)
	       return "<p><b>SEO Spotlight Chart SHORTCODE ERROR</b><lu><li>Check for misspelled parameters (case matters)</li><li>Check for new lines (all must reside on one long line)</li><li>Error near [" . $key . "], [" . $att . "]</li></lu><br/></p>";
	   
	   
	    $colors = "";
        for ($index=1;$index<=$this->slnumColorGroups;$index++)
        {
            $var = 'SL_COLORS_' . $index;
            $colors .= $this->$var;
            if ($index < $this->slnumColorGroups)
            {
                $colors .= ',';
            }
        }
        
        $chartConfig = shortcode_atts( array(
                'type' => $this->SL_TYPE,
                'width' => $this->SL_WIDTH,
                'height' => $this->SL_HEIGHT,
                'title' => $this->SL_TITLE,
                'minaxis' => '0',
                'groupnames' => 'Group 1,Group 2,Group 3',
                'groupcolors' => $colors,
                'valuenames' => 'test1,test2,test3,test4,test5',
                'group1values' => '0,0,0',
                'group2values' => '0,0,0',
                'group3values' => '0,0,0',
                'group1markers' => '',
                'group2markers' => '',
                'group3markers' => '',
                'markercolor' => $this->SL_MARKERCOLOR,              
                'imagealtattr' => $this->SL_IMAGEALT,
                'imagetitleattr' => $this->SL_IMAGETITLE,
                'hidechartdata' => ($this->SL_HIDECHART == true)?'true':'false',
                'chartcolor' => $this->SL_CHARTCOLOR,
                'chartfadecolor' => $this->SL_CHARTFADECOLOR,
                'datatablecss' => $this->SL_TABLECSS,
                'imgstyle' => $this->SL_IMGSTYLE,
                'watermark' => '',
                'watermarkvert' => '',
                'watermarkcolor' => $this->SL_WATERMARKCOLOR,
                'currency' => $this->SL_CURRENCY,
                'precision' => $this->SL_PRECISION,
                'grid' => $this->SL_GRID,
                'axis' => $this->SL_AXISOPTS)
			    , $atts ); 

	    // Translate strings to numerics
	    array_walk($chartConfig, array($this, 'translate_numerics'));
	   
	    // Work some default SEO stuff for the user
	    if ($chartConfig['imagealtattr'] == '')
	       $chartConfig['imagealtattr'] = $chartConfig['title'];
	    if ($chartConfig['imagealtattr'] == '')
	       $chartConfig['imagealtattr'] = "likes";       
	       	       
	    $this->chartNum++;
	    
	    $randomatic = mt_rand(0,0x7fff);
	    $randomatic = $randomatic << 16;
	    global $post;
	    if ($post)
	    {
            $randomatic = $randomatic | 0x8000;            
	    }	    
	    
	    $r = $randomatic | $this->chartNum;
        $chartDiv = 'slChartDiv' . base_convert($r, 10, 16);	
		
			    
		$chartImg = $chartDiv . '_img';
		$tableDiv = $chartDiv . '_data';


		$names = explode(",", $chartConfig['groupnames']);
		foreach ($names as $i => $value) 
		{
			$names[$i] = html_entity_decode($names[$i], ENT_NOQUOTES,'UTF-8');
		}
		$chartConfig['groupnames'] = implode(",", $names);
		
		$names = explode(",", $chartConfig['valuenames']);
		foreach ($names as $i => $value) 
		{
			$names[$i] = html_entity_decode($names[$i], ENT_NOQUOTES,'UTF-8');
		}
		$chartConfig['valuenames'] = implode(",", $names);


		if (function_exists('json_encode')) {
        	$json = json_encode($chartConfig);
        	$chartDiv = json_encode($chartDiv);
        	$chartImg = json_encode($chartImg);
        	$tableDiv = json_encode($tableDiv);
        } else {
			require_once('json_encode.php');
        	$json = Zend_Json_Encoder::encode($chartConfig);
        	$chartDiv = Zend_Json_Encoder::encode($chartDiv);
        	$tableDiv = Zend_Json_Encoder::encode($tableDiv);
        	$chartImg = Zend_Json_Encoder::encode($chartImg);
		}
			
					 	
	    if ($chartConfig['hidechartdata'] == false)
	    {
	    	if ($this->SL_TABLEALWAYSOPEN == true)
	    	{
	    		$dataShow = "<div class='slChartBuilder' style='margin:0px auto;' id="
		        .$tableDiv
		        ." style='text-align:center;display:block;' align='center'></div>";
	    	}
	    	else
	    	{
		        $dataShow = "<br/><br/><INPUT type='button' value='" 
		        .$this->SL_DATATABLE_TITLE 
		        ."' onclick='wpEasyChartToggle("
		        .$tableDiv
		        .");' style='text-align:center;' align='center' ><br/><div class='slChartBuilder' id="
		        .$tableDiv
		        ." style='text-align:center;display:none;' align='center'></div>";
	    	}
	    }
	    else
	       $dataShow = "";
		

	
        return <<<ecbCode
{$header}
<div id={$chartDiv} style='width:100%;'  style='text-align:center;' align='center'>
<!-- Easy Chart Builder by dyerware -->
<img id={$chartImg} style='{$chartConfig['imgstyle']}' alt='{$chartConfig['imagealtattr']}' title='{$chartConfig['imagetitleattr']}'  align='center' border='0' />
{$dataShow}
</div>
<script type="text/javascript">
//<![CDATA[
slEasyChart.slNewChart({$chartDiv}, {$json});
//]]>
</script>
ecbCode;
   }
   
   
   // This is for support in widgets
   public function do_shortcode($content) 
   {
    	global $shortcode_tags;
    
    	if (empty($shortcode_tags) || !is_array($shortcode_tags))
    		return $content;
    	$pattern = '(.?)\[(easychart)\b(.*?)(?:(\/))?\](?:(.+?)\[\/\2\])?(.?)';
    	return preg_replace_callback('/'.$pattern.'/s', 'do_shortcode_tag', $content);
    }
   
	public function query_install($posts) 
	{
	    $content = '';
        foreach ($posts as $post) {
            $content .= $post->post_content;
        }
        
        $this->installScripts = (bool)preg_match("/\[easychart(.*)\]/U", $content);

        return $posts;
	}  
	
	
    function RGBtoHSB ($rgb)
    {
        sscanf ($rgb, "%02x%02x%02x", $r, $g, $b);
     
        $h = 0;
        $s = 0;
        
        $min = min($r, $g, $b);
        $max = max($r, $g, $b);
        $delta = $max - $min;
        $b = $max;
        if ($max != 0) {
        	
        }
        $s = $max != 0 ? 255 * $delta / $max : 0;
        if ($s != 0) {
        	if ($r == $max) {
        		$h = ($g - $b) / $delta;
        	} else if ($g == $max) {
        		$h = 2 + ($b - $r) / $delta;
        	} else {
        		$h = 4 + ($r - $g) / $delta;
        	}
        } else {
        	$h = -1;
        }
        $h *= 60;
        if ($h < 0) {
        	$h += 360;
        }
        $s *= 100/255;
        $b *= 100/255;
 
        return array($h, $s, $b);
    }
}  

// Instantiate our class
$sl_Charts = new sl_Charts();

/**
 * Add filters and actions
 */

add_action('wp_print_scripts', array($sl_Charts, 'output_scripts'));

add_shortcode('slchart',array($sl_Charts, 'sl_process_shortcode'));
add_filter('the_posts', array($sl_Charts, 'query_install'));
?>