<?php          
/* Initializes all the plugin settings option fields for admin area. */

function admin_option_fields() {
    global $admin_options,$slSeo;
    $prefix = $slSeo->prefix;

    $admin_options = array();
	if(isset($_REQUEST['page'])) {
	
	if( $_REQUEST['page'] == 'seo-spotlight-ultimate/seo_spotlight_ultimate.php' ) {

   $admin_options[] = array(
        "name" => "Enable auto-check blog post/page",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "autoCheck",
        "std" => "",
        "type" => "checkbox"
    );
 
    $admin_options[] = array(
        "name" => "Show SEO score of a blog page/post",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "showScoreSeo",
        "std" => "",
        "type" => "checkbox"
    );
	
	  $admin_options[] = array(
        "name" => " Add autocheck value seconds",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "autoCheckTimes",
        "std" => "",
        "type" => "text",
        "width" => "80"
    );
	
	$admin_options[] = array(
        "name" => "Display SEO Score in Progress Bar",
        "desc" => "By default show in Gauge Dial",
        "id" => "{$prefix}" . "_" . "seoscorebar",
        "std" => "",
        "type" => "checkbox"
    );
	
	$admin_options[] = array(
        "name" => "<a href='https://www.google.com/webmasters/tools/dashboard?hl=en&amp;siteUrl=http%3A%2F%2Flocalhost%2Fseo_plugin%2F' target='_blank'>Google Webmaster Tools</a>",
        "desc" => "Verify your site for Video sitemap in Google Webmaster Tools",
        "id" => "{$prefix}" . "_" . "GWT",
        "std" => "",
        "type" => "text",
		 "width" => "200"
    );        
    update_option("{$slSeo->prefix}_admin_options", $admin_options);
	
	 }
	}
}
?>
<?php
/* slSeo Admin (plugin) control Page */
function slSeo_create_settings_page(){
?>

<div class="wrap" id="slSeo_fields">
	<div class="plugin_header">
		<div class="plugin_name_author">
			<h2>SEO Spotlight Ultimate Main Control Settings</h2>
		</div>
	</div>    
	
<?php 
	$action_response = slSeo_save_admin_options();
	if ( $action_response == 'saved' ) { ?>
		<div style="clear:both;height:5px;"></div><div class="happy">SEO Spotlight Ultimate Options has been updated!</div>
<?php } 
	if ( $action_response == 'reset' ) { ?>
		<div style="clear:both;height:5px;"></div><div class="warning">SEO Spotlight Ultimate Options has been reset!</div>
<?php } 

	// Errors
	/* Check if no duplicate id options */
	function check_option_ids() {
		global $admin_options, $all_ids, $slSeo;

		$errors_print = '';
		
		$options = array_merge($admin_options);
		
		slseo_array_walk_recursive($options, 'all_ids');
		$all_ids = array_count_values($all_ids);
		
		foreach($all_ids as $id => $count) {
			if($count>1) $errors_print .= "The ID <b>$id</b> is repeating $count times. <br />";
		}
		return $errors_print;
	}
	
	function all_ids($item, $key) { 
		global $all_ids; 
		if($key === "id") $all_ids[] = $item;
	}    
	$errors_print = '';
	
	$errors_print .= check_option_ids();
	
	$error_occurred = false;
	
	if($errors_print<>'') {
		$error_occurred = true;
	}
		
	if($error_occurred) {
		$output = '<div style="clear:both;height:20px;"></div><div class="errors"><ul>' . "\n";
		$output .= $errors_print;
		$output .= '</ul></div>' . "\n";
		echo $output;
	}
	
	echo '';
	echo '<form action="'.$_SERVER["REQUEST_URI"].'" method="post"  enctype="multipart/form-data">';

	//Generate the admin page contet, all input custom data
	echo slSeo_options_page_content();
	
?>
	
	<!--<div style="clear:both;"></div>-->
	<?php  wp_nonce_field('reset_options'); echo "\n"; ?>

	<p class="submit submit-footer" style="margin-top:0px;">
		<input name="save" type="submit" value="Save All Changes" />
		<input type="hidden" name="slSeo_save" value="save" />
	</p>
</form>
    
<!--<div style="clear:both;"></div> -->    
</div>
 <?php   
} 

// Function will be called in below function
function slSeo_save_options($options = null) {
	global $slSeo;
	$prefix = $slSeo->prefix;

	foreach ($options as $option) { 
	
		if(is_array($option['type'])) {  
			foreach($option['type'] as $array){
				if($array['type'] == 'text'){
					slSeo_save_text($array);
				}
			}
		}

		switch ( $option['type'] ) {		
			case 'text':
				slSeo_save_text($option);
				break;
	        
	        case 'checkbox':
				slSeo_save_checkbox($option);
				break;
	        
	        default:
	        	slSeo_save_default($option);
		}
	}
	
	if ( $_REQUEST['page'] == 'seo-spotlight-ultimate/seo_spotlight_ultimate.php' && $_REQUEST['slSeo_save'] == 'save' ) {
		return 'saved';
	}	
}

// Saving option to Database
function slSeo_save_admin_options() {
	if ( isset($_REQUEST['page']) && $_REQUEST['page'] == 'seo-spotlight-ultimate/seo_spotlight_ultimate.php' ) {
	 	if ( isset($_REQUEST['slSeo_save']) && 'save' == $_REQUEST['slSeo_save'] ) {
	 		global $admin_options;
	 		return slSeo_save_options($admin_options);
			
	 	} 
	}
}
?>