<?php

global $slSeo,$wpdb;



require_once(SLSEO_PLUGIN_ADMIN . '/duplicate-post.cls.php');

$wpdb->query("alter table $wpdb->posts ENGINE = MYISAM ");

$wpdb->query("alter table $wpdb->posts ADD FULLTEXT sldup_reports (post_content) ");



/**

 * Holds all the necessary functions and variables

 */

class CheckDuplicatePost extends DuplicatePostChecker

{

	/**

	 * Constructor. Adds plugin's actions/filters.

	 */

	function CheckDuplicatePost() { 

		global $wp_version, $table_prefix;

		$this->wp_posts_table  	 = $table_prefix . $this->wp_posts_table;

		$this->wp_options_table  = $table_prefix . $this->wp_options_table;

		

		$this->dpc_abspath = str_replace("\\","/",ABSPATH); 

		

		$this->dpc_activate = get_option('dpc_activate');

			add_action('init', array(&$this, 'sldupAddButtonInEditor'));

			add_action('admin_footer', array(&$this, 'sldupDuplicatePostChecker'));

	}

	

	/**

	 * Adds Duplicate Checker Button in write post/page - editor visual mode

	 * @access public

	 */

	function sldupAddButtonInEditor() {

		global $wp_version;

		if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;

		

		// Create the buttons based on the WP version number

		if ( 'true' == get_user_option('rich_editing') && $wp_version >= 2.1 ) {

			if ( $wp_version >= 2.5 ) { // WordPress 2.5+ (TinyMCE 3.x)

				global $post,$wp;

				add_filter( 'mce_external_plugins', array(&$this, 'mce_external_plugins') );

				if(get_post_type($_GET['post']) == 'post')

				add_filter( 'mce_buttons_3', array(&$this, 'mce_buttons') );

			}

		} 

	}

	function mce_external_plugins( $plugins ) {

		$plugins['duplicate_post_checker'] = SLSEO_ADMIN_JS.'/tinymce3/editor_plugin.js';

		return $plugins;

	}

	

	function mce_buttons($buttons) {

		global $wp_version;

		if ( $wp_version < 2.5 ) {

			array_push($buttons, 'duplicate_post_checker');

		} else {

			array_push($buttons, 'sldupButton');

		}

		return $buttons;

	}

	

	/**

	 * Opens up duplicate content checker panel

	 * @access public

	 */

	function sldupDuplicatePostChecker() {

		$this->__dpcOpenDuplicatePostCheckerPanel();

	}



	

	/**

	 * Plugin's manage page

	 * @access public 

	 */

	function sldupManagePg() {

		global $wpdb;

			$this->__dpcShowOptionsPg();



	}



} // Eof Class

$CheckDuplicatePost = new CheckDuplicatePost(); 

?>