<?php 
// Function to add options for On Page Features
function admin_feature_fields() {
    global $admin_features, $slSeo;
    $prefix = $slSeo->prefix;

	$admin_features = array();
	
	if( isset($_REQUEST['page'] )) {
	if( $_REQUEST['page'] == 'seosl_features' ) {

    $admin_features[] = array(
        "name" => "Use Keyword phrase in title tag",
        "desc" => "Title tag 10 - 60 characters, no special characters",
        "id" => "{$prefix}" . "_" . "keyword_title_tag",
        "std" => "",
        "type" => "checkbox"
    );
        
    $admin_features[] = array(
        "name" => "Use Keyword phrase in description",
        "desc" => "Less than 200 chars.",
        "id" => "{$prefix}" . "_" . "keyword_meta_description",
        "std" => "",
        "type" => "checkbox"
    );
        
    $admin_features[] = array(
        "name" => "Use Keyword phrase in 'keywords' meta tag",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "keyword_meta_keywords",
        "std" => "",
        "type" => "checkbox"
    );    
        
    $admin_features[] = array(
        "name" => "Use density of keyword or keyword phrase",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "keyword_meta_density",
        "std" => "",
        "type" => "checkbox"
    );
        
    $admin_features[] = array(
        "name" => "Use Keyword phrase density",
        "desc" => "",
		 "id" => "{$prefix}" . "_" . "keyword_density",
        "std" => "",
        "type" => "text",
        "width" => '120'
    );
	
	 $admin_features[] = array(
        "name" => "Use Link phrase density",
        "desc" => "",
		 "id" => "{$prefix}" . "_" . "link_density",
        "std" => "",
        "type" => "text",
        "width" => '120'
    );
	
	 $admin_features[] = array(
        "name" => "Use density of links",
        "desc" => "",
		 "id" => "{$prefix}" . "_" . "link_meta_density",
        "std" => "",
        "type" => "checkbox"
    );
      
    $admin_features[] = array(
        "name" => "Use Keyword phrase in H1",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "keyword_meta_H1",
        "std" => "",
        "type" => "checkbox"
    );
        
    $admin_features[] = array(
        "name" => "Use Keyword phrase in H2",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "keyword_meta_H2",
        "std" => "",
        "type" => "checkbox"
    );
      
   $admin_features[] = array(
        "name" => "Use Keyword phrase in H3",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "keyword_meta_H3",
        "std" => "",
        "type" => "checkbox"
    );     
        
    $admin_features[] = array(
        "name" => "Use Keyword phrase styles (bold, italic, strong etc)",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "keyword_meta_fontsize",
        "std" => "",
        "type" => "checkbox"
    );   
        
    $admin_features[] = array(
        "name" => "Use Keyword phrase in alt text of images",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "keyword_meta_img_alt",
        "std" => "",
        "type" => "checkbox"
    );
   	update_option("{$slSeo->prefix}_admin_features", $admin_features);

     }
	}
        
  }
  
add_action('admin_head', 'admin_feature_fields' );

// Function that shows form of On Page features in admin
function slSeo_onpage_features_page(){
	global $slSeo, $prefix;
	$prefix = $slSeo->prefix;
	$errors_print = '';
?>

<div class="wrap" id="slSeo_fields">
	<div class="plugin_header">
		<div class="plugin_name_author">
			<h2>SEO Spotlight Ultimate On Page features</h2>
		</div>
	</div> 

<?php 
	$action_response = slSeo_save_onpage_options();
	if ( $action_response == 'saved' ) { ?>
		<div style="clear:both;height:5px;"></div><div class="happy">SEO Spotlight's On Page features has been updated!</div>
<?php } 
	if ( $action_response == 'reset' ) { ?>
		<div style="clear:both;height:5px;"></div><div class="warning">SEO Spotlight's Options has been reset!</div>
<?php } 

// Errors
	/* Check if no duplicate id options */
	function check_option1_ids() {
		global $admin_features, $all_ids, $slSeo;

		$errors_print = '';
		
		$options = array_merge($admin_features);
		
		slseo_array_walk_recursive($options, 'all_ids');
		$all_ids = array_count_values($all_ids);
		
		foreach($all_ids as $id => $count) {
			if($count>1) $errors_print .= "The ID <b>$id</b> is repeating $count times. <br />";
		}
		return $errors_print;
	}
	
	function all_ids($item, $key) { 
		global $all_ids; 
		if($key === "id") $all_ids[] = $item;
	}    
	
	$errors_print .= check_option1_ids();
	
	$error_occurred = false;
	
	if($errors_print<>'') {
		$error_occurred = true;
	}
		
	if($error_occurred) {
		$output = '<div style="clear:both;height:20px;"></div><div class="errors"><ul>' . "\n";
		$output .= $errors_print;
		$output .= '</ul></div>' . "\n";
		echo $output;
	}

	echo '';
	echo '<form action="'.$_SERVER["REQUEST_URI"].'" method="post"  enctype="multipart/form-data">';

	//Generate the admin page content, all input custom data
	echo slSeo_options_page_feature();
	?>
	<!--<div style="clear:both;"></div>-->
	<?php  wp_nonce_field('reset_options'); echo "\n"; ?>

	<p class="submit submit-footer" style="margin-top:0px;">
		<input name="save" type="submit" value="Save All Changes" />
		<input type="hidden" name="slSeo_features_save" value="save" />
	</p>
</form>
    
<!--<div style="clear:both;"></div>-->    
</div><!-- end wrap div -->

<?php 
}
?>
<?php 
// check request from current page and call function to save
function slSeo_save_onpage_options() {
	if ( isset($_REQUEST['page']) && $_REQUEST['page'] == 'seosl_features' ) {
	 	if ( isset($_REQUEST['slSeo_features_save']) && 'save' == $_REQUEST['slSeo_features_save'] ) 				      	{			
	 		global $admin_features;
	 		return slSeo_save_features_options($admin_features);
			
	 	}
	}
}

// Save on page options in database
function slSeo_save_features_options($options = null) {

	global $slSeo;
	$prefix = $slSeo->prefix;

	foreach ($options as $option) { 
		if(is_array($option['type'])) {  
			foreach($option['type'] as $array){
				if($array['type'] == 'text'){
					slSeo_save_text($array);
				}
			}
		}

		switch ( $option['type'] ) {		
			case 'text':
				slSeo_save_text($option);
				break;
	        
	        case 'checkbox':
				slSeo_save_checkbox($option);
				break;
	 
	        default:
	        	slSeo_save_default($option);
		}
	}
	
	if ( $_REQUEST['page'] == 'seosl_features' && $_REQUEST['slSeo_features_save'] == 'save' ) {
		return 'saved';
	}	
}
?>