<?php   
/* Initializes all the plugin settings option fields for posts area. */
function post_option_fields() {
    global $slSeo, $post_options;
    $prefix = $slSeo->prefix;
    $post_options = array();

    // Primary Keyword Phrase:
    $post_options[] = array(
        "name" => "Keyword Phrase:",
        "desc" => "Use either a single keyword or multi-word phrase",
        "id" => "{$prefix}" . "_" . "primary_keyword",
        "std" => "",
        "width" => "300",
        "type" => "text"
    );
	
	   // Custom publisher Option
    $post_options[] = array(
        "name" => "Title:",
        "desc" => "Keyword phrase in 'title' tag:
                    <ul>
                        <li>Title tag 10 - 60 characters, no special characters</li>
                    </ul>",
        "id" => "{$prefix}" . "_" . "title",
        "std" => "",
        "width" => "400",
        "type" => "text"
    );

    $post_options[] = array(
        "name" => "Description:",
        "desc" => "Keyword phrase in 'description' Meta tag:
                    <ul>
                        <li>Less than 200 chars.</li>
                    </ul>",
        "id" => "{$prefix}" . "_" . "description",
        "std" => "",
        "width" => "350",
        "height" => "90",
        "type" => "textarea"
    );
	
	 $post_options[] = array(
        "name" => "Keywords:",
        "desc" => "<b>Keyword phrase in 'keyword' Meta tag <i>(comma separated)</i>: </b>
                    <ul>
                        <li>Less than 10 words or phrases.</li>
                        <li>Every word or phrase in this tag MUST appear somewhere in the body.<br /></li>
                        <li>NO single word or phrase should appear more than twice in the<br /> Meta tag as it is
                    considered spam.</li>
                     
                    </ul>",
        "id" => "{$prefix}" . "_" . "keywords",
        "std" => "",
        "width" => "400",
        "type" => "text"
    );
        
    $post_options[] = array(
        "name" => "Last score",
        "desc" => "",
        "id" => "{$prefix}" . "_" . "lastScore",
        "std" => "",
        "width" => "60",
        "type" => "text",
        "readonly" => true
    );

    /* END custom_option_fields() */
    update_option("{$prefix}_post_options", $post_options);
    // END custom_option_fields()

    return $post_options;
}
/* when the post is saved, save the custom data */
function slSeo_post_markers_save_postdata($post_id) {
    global $slSeo;
    $prefix = $slSeo->prefix;
    // verify this with nonce because save_post can be triggered at other times
    $nonce = isset($_POST['slSeo_post_markers_noncename']) ? $_POST['slSeo_post_markers_noncename'] : '';
    if (!wp_verify_nonce($nonce, 'nyc-slSeo'))
        return $post_id;

    // do not save if this is an auto save routine
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
        return $post_id;

    foreach (post_option_fields () as $key => $value) {
        update_post_meta($post_id, $value['id'], $_POST[$value['id']]);
    }
}

/* prints the custom field in the new custom post section */
function slSeo_livescore_custom_box() {
    //get post meta value
    global $post, $slSeo;
    $prefix = $slSeo->prefix;
	// check the page action
	global $current_screen; 
  	if(($current_screen->post_type =='post' && $current_screen->action == 'add') || ( $current_screen->post_type =='page' && $current_screen->action == 'add'))
	{ 
		$screen_action = "add_action";
	}
	$slSeo_keyword_title_tag = get_post_meta($post->ID, 'slSeo_keyword_title_tag', true);
	$slSeo_keyword_meta_description = get_post_meta($post->ID, 'slSeo_keyword_meta_description', true);
	$slSeo_keyword_meta_keywords = get_post_meta($post->ID, 'slSeo_keyword_meta_keywords', true);
	$slSeo_keyword_meta_density = get_post_meta($post->ID, 'slSeo_keyword_meta_density', true);
	$slSeo_keyword_density = get_post_meta($post->ID, 'slSeo_keyword_density', true);
	$slSeo_link_density = get_post_meta($post->ID, 'slSeo_link_density', true);
	$slSeo_link_meta_density = get_post_meta($post->ID, 'slSeo_link_meta_density', true);
	$slSeo_keyword_meta_H1 = get_post_meta($post->ID, 'slSeo_keyword_meta_H1', true);
	$slSeo_keyword_meta_H2 = get_post_meta($post->ID, 'slSeo_keyword_meta_H2', true);
	$slSeo_keyword_meta_H3 = get_post_meta($post->ID, 'slSeo_keyword_meta_H3', true);
	$slSeo_keyword_meta_fontsize = get_post_meta($post->ID, 'slSeo_keyword_meta_fontsize', true);
	$slSeo_keyword_meta_img_alt = get_post_meta($post->ID, 'slSeo_keyword_meta_img_alt', true);
	if($slSeo_keyword_title_tag == 'false' && $slSeo_keyword_meta_description == 'false' && $slSeo_keyword_meta_keywords == 'false' && $slSeo_keyword_meta_density == 'false' && $slSeo_keyword_density == '' && $slSeo_link_density == '' && $slSeo_link_meta_density == 'false' && $slSeo_keyword_meta_H1 == 'false' && $slSeo_keyword_meta_H2 == 'false' && $slSeo_keyword_meta_H3 == 'false' && $slSeo_keyword_meta_fontsize == 'false' && $slSeo_keyword_meta_img_alt == 'false')
	{
		$seo_page_setting = 'blank';
	}
?> 
<div id="slSeoChecklist">
   <!-- <div id="slSeoOverlay"><h1>SEO check ...</h1></div>-->
    <div id="progress_bar" class="ui-progress-bar ui-container">
      <div class="ui-progress" style="width: 0%;">
        <span class="ui-label"> </span>
      </div>
    </div>
	<div id="chart_div"></div>
    <br />
    <h2 style="margin-left:0px; text-align:center;">SEO Spotlight Checklist</h2>
    <!-- seo checklist !-->
    <table class="widefat post fixed slSeoTable" cellspacing="0">
        <tbody>
            <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_title_tag') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_title_tag',true) != "true" ? 'style="display:none;"' : ''; } ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_title_tag" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase in title tag</td>
                <td width="18">
                </td>
            </tr>
			  <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_description') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_description',true) != "true" ? 'style="display:none;"' : ''; } ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_description" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase in description Meta tag</td>
                <td width="18">
                 </td>
            </tr>
			  <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_keywords') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_keywords',true) != "true" ? 'style="display:none;"' : '';} ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_keywords" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase in keyword Meta tag</td>
                <td width="18">
                </td>
            </tr>
			 <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_density') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_density',true) != "true" ? 'style="display:none;"' : '';} ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_density" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase density in body text <strong><?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_density');}else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_density',true); }?>%</strong> (keywords/ total words). Should be within +/- 1%. <div>Current density: <strong id="seoCurretDensity">0%</strong></div></td>
                <td width="18"></td>
            </tr>
			 <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'link_meta_density') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'link_meta_density',true) != "true" ? 'style="display:none;"' : '';} ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-link_meta_density" width="18" height="18" alt="OK"></td>
                <td valign="center">Link phrase density in body text <strong><?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){echo get_option($prefix . '_' . 'link_density');} else { echo get_post_meta($post->ID,$prefix . '_' . 'link_density',true); }?> % </strong> Should be within +/- 1%. <div>Current density: <strong id="seoCurretlinkDensity">0%</strong></div></td>
                <td width="18"></td>
            </tr>
			
			<tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_H1') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_H1',true) != "true" ? 'style="display:none;"' : '';} ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_H1" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase in H1</td>
                <td width="18"></td>
            </tr>
			 <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_H2') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_H2',true) != "true" ? 'style="display:none;"' : ''; } ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_H2" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase in H2</td>
                <td width="18"></td>
            </tr>
            
            <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_H3') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_H3',true) != "true" ? 'style="display:none;"' : ''; } ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_H3" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase in H3</td>
                <td width="18"></td>
            </tr>
			   <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_fontsize') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_fontsize',true) != "true" ? 'style="display:none;"' : ''; } ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_fontsize" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase styles (bold, italic, strong etc).</td>
                <td width="18"></td>
            </tr>
			 <tr <?php if(($screen_action == 'add_action') || ($seo_page_setting == 'blank')){ echo get_option($prefix . '_' . 'keyword_meta_img_alt') != "true" ? 'style="display:none;"' : ''; } else { echo get_post_meta($post->ID,$prefix . '_' . 'keyword_meta_img_alt',true) != "true" ? 'style="display:none;"' : ''; } ?>>
                <td width="18"><img src="<?php echo SLSEO_PLUGIN_URI;?>sl_admin/images/no3.gif" id="stats-keyword_meta_img_alt" width="18" height="18" alt="OK"></td>
                <td valign="center">Keyword phrase in alt text of images</td>
            </tr>
			
			    <tr>
                <td valign="center" colspan="3" style="position: relative;"><input type="submit" class="button button-highlighted" value="SEO check" id="slSeoCheck" name="slSeoCheck" />
                <span class="seoCountDown"> Recheck in: <strong id="seoTimeMarker">10</strong> <i>seconds</i></span>
                </td>
            </tr>
           
        </tbody>
    </table>
</div>

<?php      
}  
/* use save_post action to handle data entered */
add_action('save_post', 'slSeo_post_markers_save_postdata');


/*===========Addming Meta Box for ON Page SEO Settings ==============*/

add_action( 'add_meta_boxes', 'on_page_seo_setting_box' );
function on_page_seo_setting_box() {
    add_meta_box( 
        'on_page_seo_setting_box',
        __( 'On Page SEO Setting', 'myplugin_textdomain' ),
        'on_page_seo_setting_box_content',
        'post',
        'normal',
        'high'
    );
	 add_meta_box( 
        'on_page_seo_setting_box',
        __( 'On Page SEO Setting', 'myplugin_textdomain' ),
        'on_page_seo_setting_box_content',
        'page',
        'normal',
        'high'
    );
}
function on_page_seo_setting_box_content( $post ) {
	global $wpdb, $post;
	$slSeo_keyword_title_tag = get_post_meta($post->ID, 'slSeo_keyword_title_tag', true);
	$slSeo_keyword_meta_description = get_post_meta($post->ID, 'slSeo_keyword_meta_description', true);
	$slSeo_keyword_meta_keywords = get_post_meta($post->ID, 'slSeo_keyword_meta_keywords', true);
	$slSeo_keyword_meta_density = get_post_meta($post->ID, 'slSeo_keyword_meta_density', true);
	$slSeo_keyword_density = get_post_meta($post->ID, 'slSeo_keyword_density', true);
	$slSeo_link_density = get_post_meta($post->ID, 'slSeo_link_density', true);
	$slSeo_link_meta_density = get_post_meta($post->ID, 'slSeo_link_meta_density', true);
	$slSeo_keyword_meta_H1 = get_post_meta($post->ID, 'slSeo_keyword_meta_H1', true);
	$slSeo_keyword_meta_H2 = get_post_meta($post->ID, 'slSeo_keyword_meta_H2', true);
	$slSeo_keyword_meta_H3 = get_post_meta($post->ID, 'slSeo_keyword_meta_H3', true);
	$slSeo_keyword_meta_fontsize = get_post_meta($post->ID, 'slSeo_keyword_meta_fontsize', true);
	$slSeo_keyword_meta_img_alt = get_post_meta($post->ID, 'slSeo_keyword_meta_img_alt', true);
	wp_nonce_field( plugin_basename( __FILE__ ), 'on_page_seo_setting_box_content_nonce' );
?>
<div class="on_page_setting_container">
	<p class="onpage_seo_message">Please update the post for applying the local SEO page setting after choosing the On Page SEO setting options.</p>
    <div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase in title tag</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_title_tag" id="slSeo_keyword_title_tag" value="true" <?php if($slSeo_keyword_title_tag == 'true'){ ?> checked="checked" <?php } ?> >
      </div>
      <div class="desc">Title tag 10 - 60 characters, no special characters</div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase in description</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_description" id="slSeo_keyword_meta_description" value="true" <?php if($slSeo_keyword_meta_description == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc">Less than 200 chars.</div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase in 'keywords' meta tag</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_keywords" id="slSeo_keyword_meta_keywords" value="true" <?php if($slSeo_keyword_meta_keywords == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use density of keyword or keyword phrase</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_density" id="slSeo_keyword_meta_density" value="true" <?php if($slSeo_keyword_meta_density == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-text">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase density</label>
    <div class="formcontainer">
      <div class="forminp"> 
        <input name="slSeo_keyword_density" style="width: 120px" id="slSeo_keyword_density" type="text" value="<?php echo $slSeo_keyword_density; ?>" >
        <br>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-text">
  <div class="option-inner">
    <label class="titledesc">Use Link phrase density</label>
    <div class="formcontainer">
      <div class="forminp">
        <input name="slSeo_link_density" style="width: 120px" id="slSeo_link_density" type="text" value="<?php echo $slSeo_link_density; ?>" >
        <br>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use density of links</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_link_meta_density" id="slSeo_link_meta_density" value="true" <?php if($slSeo_link_meta_density == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase in H1</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_H1" id="slSeo_keyword_meta_H1" value="true" <?php if($slSeo_keyword_meta_H1 == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase in H2</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_H2" id="slSeo_keyword_meta_H2" value="true" <?php if($slSeo_keyword_meta_H2 == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase in H3</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_H3" id="slSeo_keyword_meta_H3" value="true" <?php if($slSeo_keyword_meta_H3 == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase styles (bold, italic, strong etc)</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_fontsize" id="slSeo_keyword_meta_fontsize" value="true" <?php if($slSeo_keyword_meta_fontsize == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
<div class="option option-checkbox">
  <div class="option-inner">
    <label class="titledesc">Use Keyword phrase in alt text of images</label>
    <div class="formcontainer">
      <div class="forminp">
        <input type="checkbox" class="single_checkbox" name="slSeo_keyword_meta_img_alt" id="slSeo_keyword_meta_img_alt" value="true" <?php if($slSeo_keyword_meta_img_alt == 'true'){ ?> checked="checked" <?php } ?>>
      </div>
      <div class="desc"></div>
    </div>
  </div>
</div>
<div class="clear"></div>
</div>
<?php
} 
add_action( 'save_post', 'on_page_seo_setting_save' );
function on_page_seo_setting_save( $post_id ) { 

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	return;

	if ( !wp_verify_nonce( $_POST['on_page_seo_setting_box_content_nonce'], plugin_basename( __FILE__ ) ) )
	return;

	if ( 'post' == $_POST['post_type'] || 'page' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_page', $post_id ) )
		return;
	} else {
		if ( !current_user_can( 'edit_post', $post_id ) )
		return;
	} 
	//$orig_article_url = $_POST['orig_article_url'];
	$slSeo_keyword_title_tag = $_POST['slSeo_keyword_title_tag'];
	$slSeo_keyword_meta_description = $_POST['slSeo_keyword_meta_description'];
	$slSeo_keyword_meta_keywords = $_POST['slSeo_keyword_meta_keywords'];
	$slSeo_keyword_meta_density = $_POST['slSeo_keyword_meta_density'];
	$slSeo_keyword_density = $_POST['slSeo_keyword_density'];
	$slSeo_link_density = $_POST['slSeo_link_density'];
	$slSeo_link_meta_density = $_POST['slSeo_link_meta_density'];
	$slSeo_keyword_meta_H1 = $_POST['slSeo_keyword_meta_H1'];
	$slSeo_keyword_meta_H2 = $_POST['slSeo_keyword_meta_H2'];
	$slSeo_keyword_meta_H3 = $_POST['slSeo_keyword_meta_H3'];
	$slSeo_keyword_meta_fontsize = $_POST['slSeo_keyword_meta_fontsize'];
	$slSeo_keyword_meta_img_alt = $_POST['slSeo_keyword_meta_img_alt'];
	if($slSeo_keyword_title_tag == ''){$slSeo_keyword_title_tag = 'false';}
	if($slSeo_keyword_meta_description == ''){$slSeo_keyword_meta_description = 'false';} 
	if($slSeo_keyword_meta_keywords == ''){$slSeo_keyword_meta_keywords = 'false';}
	if($slSeo_keyword_meta_density == ''){$slSeo_keyword_meta_density = 'false';}
	if($slSeo_link_meta_density == ''){$slSeo_link_meta_density = 'false';}
	if($slSeo_keyword_meta_H1 == ''){$slSeo_keyword_meta_H1 = 'false';}
	if($slSeo_keyword_meta_H2 == ''){$slSeo_keyword_meta_H2 = 'false';}
	if($slSeo_keyword_meta_H3 == ''){$slSeo_keyword_meta_H3 = 'false';}
	if($slSeo_keyword_meta_fontsize == ''){$slSeo_keyword_meta_fontsize = 'false';}
	if($slSeo_keyword_meta_img_alt == ''){$slSeo_keyword_meta_img_alt = 'false';}
	update_post_meta( $post_id, 'slSeo_keyword_title_tag', $slSeo_keyword_title_tag );
	update_post_meta( $post_id, 'slSeo_keyword_meta_description', $slSeo_keyword_meta_description );
	update_post_meta( $post_id, 'slSeo_keyword_meta_keywords', $slSeo_keyword_meta_keywords );
	update_post_meta( $post_id, 'slSeo_keyword_meta_density', $slSeo_keyword_meta_density );
	update_post_meta( $post_id, 'slSeo_keyword_density', $slSeo_keyword_density );
	update_post_meta( $post_id, 'slSeo_link_density', $slSeo_link_density );
	update_post_meta( $post_id, 'slSeo_link_meta_density', $slSeo_link_meta_density );
	update_post_meta( $post_id, 'slSeo_keyword_meta_H1', $slSeo_keyword_meta_H1 );
	update_post_meta( $post_id, 'slSeo_keyword_meta_H2', $slSeo_keyword_meta_H2 );
	update_post_meta( $post_id, 'slSeo_keyword_meta_H3', $slSeo_keyword_meta_H3 );
	update_post_meta( $post_id, 'slSeo_keyword_meta_fontsize', $slSeo_keyword_meta_fontsize ); 
	update_post_meta( $post_id, 'slSeo_keyword_meta_img_alt', $slSeo_keyword_meta_img_alt );
}
/*===========Addming Meta Box for Import CSV file ==============*/
function on_page_seo_import() { 
	// Define the custom attachment for posts
	add_meta_box(
		'on_page_seo_import',
		'On Page CSV Upload',
		'on_page_seo_import_box',
		'post',
		'normal',
		'high'
	);	
	// Define the custom attachment for pages
	add_meta_box(
		'on_page_seo_import',
		'On Page CSV Upload',
		'on_page_seo_import_box',
		'page',
		'normal',
		'high'
	);
	echo '<script type="text/javascript">
		window.onload = function(){
		document.getElementById("post").enctype = "multipart/form-data";
		document.getElementById("page").enctype = "multipart/form-data";}
		</script>';
} // end add_custom_meta_boxes 
add_action('add_meta_boxes', 'on_page_seo_import');
function on_page_seo_import_box( $post_id )  
{
	wp_nonce_field(plugin_basename(__FILE__), 'slSeo_csv_data_nonce');  
      
    $html = '<p class="description">';  
        $html .= 'Upload your CSV file here.';  
    $html .= '</p>';  
    $html .= '<input type="file" id="slSeo_csv_data" name="slSeo_csv_data" value="" size="25">';  
      
    echo $html;  
}
function save_seo_import_data($post_id) {	
	/* --- security verification --- */
	if(!wp_verify_nonce($_POST['slSeo_csv_data_nonce'], plugin_basename(__FILE__))) {
	  return $post_id;
	} // end if
	  
	if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	  return $post_id;
	} // end if
	  
	if ( 'post' == $_POST['post_type'] || 'page' == $_POST['post_type'] ){
	  if(!current_user_can('edit_page', $post_id)) {
	    return $post_id;
	  } // end if
	}
	else {
   		if(!current_user_can('edit_page', $post_id)) {
	    	return $post_id;
	   	} // end if
	} // end if
	/* - end security verification - */
	
	 // Make sure the file array isn't empty  
	 
	 if(!empty($_FILES['slSeo_csv_data']['name'])) 
	 { 
	
        // Setup the array of supported file types. In this case, it's just PDF.  
        $supported_types = array('text/csv');
          
        // Get the file type of the upload  
        $arr_file_type = wp_check_filetype(basename($_FILES['slSeo_csv_data']['name']));  
        $uploaded_type = $arr_file_type['type'];  
          
        // Check if the type is supported. If not, throw an error.  
        if(in_array($uploaded_type, $supported_types)) 
		{  
  
            // Use the WordPress API to upload the file  
            $upload = wp_upload_bits($_FILES['slSeo_csv_data']['name'], null, file_get_contents($_FILES['slSeo_csv_data']['tmp_name']));  
      
            if(isset($upload['error']) && $upload['error'] != 0) 
			{  
                wp_die('There was an error uploading your file. The error is: ' . $upload['error']);  
            } else 
			{    
                update_post_meta($post_id, 'slSeo_csv_data', $upload);    
            } // end if/else  
  
        } 
		else 
		{  
            wp_die("The file type that you've uploaded is not a CSV. So please upload only CSV file.");  
        } // end if/else  
		
		$upload_dir = wp_upload_dir();
	  	$mycsvfile = $upload_dir['url'].'/'.$_FILES['slSeo_csv_data']['name'];
		
		if (($handle = fopen($mycsvfile, "r")) !== FALSE) 
		{
    		// this will automate things but modify the csv head for each column to represent the actual column name in your table.
    		$header = fgetcsv($handle, 1000, ",");
			$values = array();
    		while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) 
			{  
				$values[] = $data;
    		}
			$slSeo_title = str_replace(array(';','|'),',',trim($values[0][0]));
			$slSeo_primary_keyword = str_replace(array(';','|'),',',trim($values[0][1]));
			$slSeo_description = str_replace(array(';','|'),',',trim($values[0][2]));
			$slSeo_keywords = str_replace(array(';','|'),',',trim($values[0][3]));
			update_post_meta( $post_id, 'slSeo_title', $slSeo_title);
			update_post_meta( $post_id, 'slSeo_primary_keyword', $slSeo_primary_keyword);
			update_post_meta( $post_id, 'slSeo_description', $slSeo_description); 
			update_post_meta( $post_id, 'slSeo_keywords', $slSeo_keywords);  
			fclose($handle);
		}
    }
}
add_action('save_post', 'save_seo_import_data');