<?php
// To show form for social report settings
function sl_socialReports_settings() {
	global $slSeo, $prefix;
	$prefix = $slSeo->prefix;

	$errors_print = '';
?>

<div class="wrap" id="slSeo_fields">
	<div class="plugin_header">
		<div class="plugin_name_author" style="width:550px;">
			<h2>SEO Spotlight Ultimate Social Reports Settings</h2>
		</div>
	</div> 
<?php 
	$report_response = slSeo_save_reports_options();
	if ( $report_response == 'saved' ) { ?>
		<div style="clear:both;height:5px;"></div><div class="happy">SEO Spotlight's Social Reports Settings has been updated!</div>
<?php } 

// Errors
	/* Check if no duplicate id options */
	function check_reportOptions_ids() {
		global $admin_reports_options, $all_ids, $slSeo;
		$errors_print = '';
		
		$options = array_merge($admin_reports_options);
		
		slseo_array_walk_recursive($options, 'all_ids');
		$all_ids = array_count_values($all_ids);
		
		foreach($all_ids as $id => $count) {
			if($count>1) $errors_print .= "The ID <b>$id</b> is repeating $count times. <br />";
		}// foreach end
		return $errors_print;
	}
	
	function all_ids($item, $key) { 
		global $all_ids; 
		if($key === "id") $all_ids[] = $item;
	}    
	
	$errors_print .= check_reportOptions_ids();
	
	$error_occurred = false;
	
	if($errors_print<>'') {
		$error_occurred = true;
	}
	
	if($error_occurred) {
		$output = '<div style="clear:both;height:20px;"></div><div class="errors"><ul>' . "\n";
		$output .= $errors_print;
		$output .= '</ul></div>' . "\n";
		echo $output;
	}
	
	echo '';
	echo '<form action="'.$_SERVER["REQUEST_URI"].'" method="post"  enctype="multipart/form-data">';

	//Generate the admin page content, all input custom data
	echo slSeo_reportsOptions_fields();
	?>
	<!--<div style="clear:both;"></div>-->
	<?php  wp_nonce_field('reset_options'); echo "\n"; ?>

	<p class="submit submit-footer" style="margin-top:0px !important;">
		<input name="save" type="submit" value="Save All Changes" />
		<input type="hidden" name="slSeo_reportsOptions_save" value="save" />
	</p>
</form>
    
<!--<div style="clear:both;"></div>-->    
</div>

<?php           
} 

// Check for request from current page and call function to save fields
function slSeo_save_reports_options() {
	if ( isset($_REQUEST['page']) && $_REQUEST['page'] == 'socialreports_settings' ) {
	 	if ( isset($_REQUEST['slSeo_reportsOptions_save']) && 'save' == $_REQUEST['slSeo_reportsOptions_save'] ) {			
	 		global $admin_reports_options;
	 		return slSeo_save_socialReports_options($admin_reports_options);
	 	}
	}
}

// Save Social Reports fields values
function slSeo_save_socialReports_options($options = null) {

	global $slSeo;
	$prefix = $slSeo->prefix;

	foreach ($options as $option) { 
		if(is_array($option['type'])) {  
			foreach($option['type'] as $array){
				if($array['type'] == 'text'){
					slSeo_save_text($array);
				}
			}
		}
		//switch case for each field text,checkbox
		switch ( $option['type'] ) {		
			case 'text':
				slSeo_save_text($option);
				break;
	        
	        case 'checkbox':
				slSeo_save_checkbox($option);
				break;
				
	        default:
	        	slSeo_save_default($option);
		}
	}
	
		if ( $_REQUEST['page'] == 'socialreports_settings' && $_REQUEST['slSeo_reportsOptions_save'] == 'save' ) {
			return 'saved';
		}	
}

// To Show social reports options fields
function admin_socialReports_fields() {
    global $admin_reports_options, $slSeo;
    $prefix = $slSeo->prefix;

	$admin_reports_options = array();
	
	if( isset($_REQUEST['page'] )) {
		if( $_REQUEST['page'] == 'socialreports_settings' ) {
		
		 $admin_reports_options[] = array(
			"name" => "Number of posts to display in Social Reports",
			"desc" => "",
			 "id" => "{$prefix}" . "_" . "no_posts_reports",
			"std" => "5",
			"type" => "text",
			"width" => '50'
		);
		
		$admin_reports_options[] = array(
			"name" => "Show Social Reports for Facebook",
			"desc" => "",
			"id" => "{$prefix}" . "_" . "reports_facebook",
			"std" => "true",
			"type" => "checkbox"
		);
	
		$admin_reports_options[] = array(
			"name" => "Show Social Reports for Twitter",
			"desc" => "",
			"id" => "{$prefix}" . "_" . "reports_twitter",
			"std" => "true",
			"type" => "checkbox"
		);    
			
		$admin_reports_options[] = array(
			"name" => "Show Social Reports for Google+",
			"desc" => "",
			"id" => "{$prefix}" . "_" . "reports_google+",
			"std" => "true",
			"type" => "checkbox"
		);
			
		update_option("{$slSeo->prefix}_social_reports_options", $admin_reports_options);
	
	   }
   }
        
}
  
add_action('admin_head', 'admin_socialReports_fields' );