//initialize variable
var slSeo = {

    option: {
        uri: '',
        seoSettings: {},
        running: false,
        autoCheck : 0,
        countDown: 0,
        maxScore: 0,
        script: 'api.php'
    },

    init: function(options) {
        var self = this;
        
        self.option = jQuery.extend({}, self.option, options);   
        
        // if not exist
        if(!jQuery("#slSeo_primary_keyword").size()){
            return false;
        }
        
        // initialize show rules function
        self.showRules();
        
        self.seoCheckUpdate();
        
        jQuery("#slSeoCheck").click(function(){
            jQuery("#seoTimeMarker").text(self.option.seoSettings.autoCheckTimes);
            self.seoCheckUpdate();
            return false;
        });
        
        // autocheck is done
        if(self.option.seoSettings.autoCheck == 'true'){
            jQuery("#seoTimeMarker").text(self.option.seoSettings.autoCheckTimes);
            self.option.countDown = setInterval(function(){self.pushCountDown()}, 1000);
        }
    },
	
	 showRules: function(){
        var self = this;

        jQuery.each(self.option.seoSettings.rulesCheck, function(key, val) {
            if(val == 'true'){
                self.option.maxScore++;
            }
        });
    },
    
    pushCountDown: function(){
        var self = this;
        
        var currCount = jQuery("#seoTimeMarker").text();
        if(currCount == 0){
            self.seoCheckUpdate();
            jQuery("#seoTimeMarker").text(self.option.seoSettings.autoCheckTimes);
        }else{
            jQuery("#seoTimeMarker").text(currCount - 1);
        }
    },

    seoCheckUpdate: function(){
        var self = this;
        
        // collision prevent
        if(self.option.running == true) return false; // exit
        
        self.option.running = true;
        
        var pageContent = '';
        if(jQuery("#edButtonHTML").hasClass('active')){
            pageContent = jQuery("#content").val();
        }else{
            pageContent = jQuery("#content_ifr").contents().find('#tinymce').html()            
        }
        if(pageContent == '' || pageContent == null){
            pageContent = jQuery("#content").val();
        }

        jQuery('#slSeoOverlay').css('display', 'block').css('height', jQuery('#slSeoChecklist').height());
        
        jQuery.post(self.option.uri + self.option.script, 
        {
            primary_keyword : jQuery("#slSeo_primary_keyword").val(),
            meta_title: jQuery("#slSeo_title").val(),
            meta_description: jQuery("#slSeo_description").val(),
            meta_keywords: jQuery("#slSeo_keywords").val(),
            content: pageContent

        }, function(data) {
            // update status
            var points = 0;
            jQuery.each(data, function(key, val) {
                if(self.option.seoSettings.rulesCheck[key] == 'true'){
					
	                if(val > 0){
                        // case for density
                        if(key == 'keyword_meta_density'){
							
                        	val = parseFloat(val);
	                        var keyword_density = self.option.seoSettings.rulesCheck['keyword_density'];
							keyword_density = parseFloat(keyword_density);
							
                            // jquery for update keyword density
                            jQuery("#seoCurretDensity").text(val + "%");

                            if(val < keyword_density && val >= (keyword_density- 1)){
                               points++;
                                jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/ok.png');
                            } else if(val > keyword_density && val <= (keyword_density + 1)){
                               points++;
                                 jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/ok.png');
                            } else {
                            	jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/no3.gif');
                            }
                            
                        } 
						// check for link meta density
						else if(key == 'link_meta_density'){
                        	val = parseFloat(val);
							//console.log(val);
							//alert(val);
	                        var link_density = self.option.seoSettings.rulesCheck['link_density'];
							link_density = parseFloat(link_density);
							
                            // update link density
                            jQuery("#seoCurretlinkDensity").text(val + "%");

                            if(val < link_density && val >= (link_density- 1)){
                               points++;
                                jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/ok.png');
                            } else if(val > link_density && val <= (link_density + 1)){
                               points++;
                                 jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/ok.png');
                            } else {
                            	jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/no3.gif');
                            }
                            
                        }else {
                            points++;
								//alert(points);
                            jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/ok.png');
                        }
						
						
                    }else{
		                // particular case for keyword density
                        if(key == 'keyword_meta_density'){
                            jQuery("#seoCurretDensity").text(val + "%");
                        } // particular case for link density

						 if(key == 'link_meta_density'){
                            jQuery("#seoCurretlinkDensity").text(val + "%");
                        }
		                
		                jQuery("#stats-" + key).attr('src', self.option.uri + 'sl_admin/images/no3.gif');
                    }
                }
            });
            
            // Hiding the label at start
            jQuery('#progress_bar .ui-progress .ui-label').hide();
            // Setting initial value here
            jQuery('#progress_bar .ui-progress').css('width', '7%');

		var progressCount = ((points / self.option.maxScore)  * 100).toFixed(1);
			
            // Simulate some progress
            jQuery('#progress_bar .ui-progress').animateProgress({
                progress : progressCount,
                duration : 1000,
                easing   : 'swing'
            }, function() { console.log(self.option);
			
			});
            
            jQuery('#slSeoChecklist table').animate({opacity: 1}, 200);
            jQuery('#slSeoOverlay').fadeOut(200);
            
            jQuery("#slSeo_lastScore").val(progressCount);
            
            // unblock script
            self.option.running = false;
        }, 'json');
    }
};

(function( $ ){
    // Simple wrapper around jQuery animate to simplify animating options.progress from your app
    $.fn.animateProgress = function(options, callback) {       
        return this.each(function() {
            var progress = options.progress;
            $(this).animate({
                width: options.progress + '%'
            }, {
                duration: options.duration, 
        
                // swing or linear
                easing: options.easing,

                // this gets called every step of the animation, and updates the label
                step: function( progress ){
                    var labelEl = $('.ui-label');

	                var valueEl = $('h3.hndle .value');
          
                    if (Math.ceil(progress) < 20 && $('.ui-label', this).is(":visible")) {
                        labelEl.hide();
                    }else{
                        if (labelEl.is(":hidden")) {
                            labelEl.fadeIn();
                        };
                    }
                    valueEl.text((progress.toFixed(1)) + '%');
                    
                },
                complete: function(scope, i, elem) {
                    if (callback) {
                        callback.call(this, i, elem );
                    };
                }
            });
        });
    };
})( jQuery );